env.info("Mission Setup : is loading.")

function merge(tbls)
	local res = {}
	for i,v in ipairs(tbls) do
		for i2,v2 in ipairs(v) do
			table.insert(res,v2)
		end
	end
	
	return res
end

function allExcept(tbls, except)
	local tomerge = {}
	for i,v in pairs(tbls) do
		if i~=except then
			table.insert(tomerge, v)
		end
	end
	return merge(tomerge)
end

upgrades = {
	redships = {
		blue = {'Hazzard Perry', 'Hazzard Perry', 'Hazzard Perry'},
		red = {'Molniya', 'Molniya', 'Molniya', 'Rezky', 'Rezky', 'Neustrashimy', 'Neustrashimy', 'Moskva'}
	},
	blueships = {
		blue = {'Hazzard Perry'},
		red = {'Moskva'}
	},
	airfield1 = {
		blue = {'blueInfantry', 'blueArmor', 'bluePD1'},
		red = {'Ground Forces 1', 'Red SAM SHORAD SA-19 Group', 'Red SAM AAA','Red SAM AAA 2', 'Red SAM SHORAD SA-19 Group 2', 'Ground Armour 2', 'Red SAM SHORAD SA-8 Group', 'Red SAM SHORAD SA-8 Group 2'}
	},
	ElGoraUpgrade = {
		blue = {'blueInfantry', 'blueArmor', 'bluePD1'},
		red = {'Ground Forces 1', 'Ground Armour', 'Red SAM AAA', 'Ground Armour 2','Red SAM AAA 2', 'Red SAM SHORAD SA-8 Group 2', 'Red SAM SHORAD SA-8 Group', 'El Gora Command Center'}
	},
	airfield2 = {
		blue = {'blueInfantry', 'blueArmor', 'bluePD1'},
		red = {'Ground Forces 1', 'Ground Armour', 'Ground Armour 3','Red SAM SHORAD SA-19 Group 2','Red SAM AAA', 'Red SAM SHORAD SA-8 Group', 'Red SAM SHORAD SA-19 Group', 'Red SAM AAA 2', 'Red SAM SHORAD SA-8 Group 2'}
	},
	airfield2Ismailiyah = {
		blue = {'blueInfantry', 'blueArmor', 'bluePD1'},
		red = {'Red SAM AAA', 'Ground Armour', 'Ground Armour 3', 'Red SAM AAA 2','Al Ismailiyah Fuel Tank', 'Red SAM SHORAD SA-19 Group 2', 'Red SAM SHORAD SA-8 Group','Al Ismailiyah HQ bulding', 'Red SAM SHORAD SA-8 Group 2', 'Red SAM SHORAD SA-19 Group'}
	},
	airfieldBen = {
		blue = {'bluePD1'},
		red = {'Ground Forces 1', 'Ground Armour', 'Ground Armour 3', 'Red SAM SHORAD SA-8 Group', 'Red SAM SHORAD SA-19 Group 2', 'Red SAM SHORAD SA-8 Group 2', 'Red SAM SHORAD SA-19 Group'}
	},
	airfield2hat = {
		blue = {'blueInfantry', 'blueArmor', 'bluePD1'},
		red = {'FixedredInfantry1-1', 'Red SAM SHORAD SA-8 Group 2', 'Ground Armour', 'Ground Armour 3', 'Red SAM AAA', 'Red SAM SHORAD SA-8 Group', 'Red SAM AAA 2', 'Red SAM SHORAD SA-19 Group', 'Kedem Fuel tanks', 'Kedem Fuel tanks 2','Kedem Fuel tanks 3','Kedem Fuel tanks 4'}
	},
	airfield3 = {
		blue = {'blueInfantry', 'blueArmor', 'bluePD2', 'blueHAWK'},
		red = {'Ground Forces 2', 'Red SAM AAA', 'Ground Armour 2', 'Ground Armour 3','Red SAM SHORAD SA-19 Group 2','Red SAM SHORAD SA-15 Group 2', 'Red SAM AAA 2', 'Red SAM SHORAD SA-19 Group', 'Red SAM SHORAD SA-15 Group'}
	},
	airfield3nevatim = {
		blue = {'blueInfantry', 'blueArmor', 'bluePD2', 'blueHAWK'},
		red = {'Ground Forces 2', 'Red SAM AAA', 'Ground Armour 2', 'Ground Armour 3','Red SAM SHORAD SA-15 Group 2','Red SAM SHORAD SA-19 Group 2', 'Red SAM AAA 2', 'Nevatim Command Center', 'Red SAM SHORAD SA-19 Group', 'Red SAM SHORAD SA-15 Group'}
	},
	Melez = {
		blue = {'blueInfantry', 'blueArmor', 'bluePD1', 'bluePATRIOT'},
		red = {'Ground Forces 2', 'Melez Ammo Depo', 'Ground Armour', 'Ground Armour 3', 'Red SAM SHORAD SA-19 Group 2', 'Red SAM AAA','Red SAM SHORAD SA-15 Group 2', 'Melez HQ bulding','Red SAM AAA 2', 'Red SAM SHORAD SA-19 Group', 'Melez Fuel Tank', 'Red SAM SHORAD SA-15 Group'}
	},
	airfield4 = {
		blue = {'blueInfantry','blueArmor', 'bluePD2'},
		red = {'Ground Forces 2', 'Ground Armour', 'Ground Armour 3','Red SAM SHORAD SA-15 Group 2', 'Red SAM SHORAD SA-8 Group 2', 'Red SAM SHORAD SA-15 Group', 'Red SAM SHORAD SA-8 Group'}
	},
	Wadi = {
		blue = {'blueInfantry','blueArmor', 'bluePD2'},
		red = {'Ground Forces 2', 'Ground Armour', 'Ground Armour 3', 'Red SAM SHORAD SA-15 Group', 'Red SAM SHORAD SA-8 Group 2','Red SAM SHORAD SA-15 Group 2', 'Wadi Al Jandali main building', 'Red SAM SHORAD SA-8 Group', 'Wadi Al Jandali Com tower'}
	},
	RamonAirbase = {
		blue = {'blueInfantry','blueArmor', 'bluePD2'},
		red = {'Ground Forces 2','Ramon Airbase Training Center','Red SAM SHORAD SA-15 Group 2', 'Red SAM AAA', 'Ground Armour 2', 'Ground Armour 3', 'Ramon Airbase HQ bulding','Red SAM SHORAD SA-8 Group', 'Red SAM AAA 2', 'Red SAM SHORAD SA-15 Group', 'Red SAM SHORAD SA-8 Group 2'}
	},
	Baluza = {
		blue = {'blueInfantry','blueArmor', 'bluePD2'},
		red = {'Ground Forces 2','Ground Armour', 'Ground Armour 3', 'Red SAM AAA','Red SAM SHORAD SA-15 Group 2','Red SAM SHORAD SA-8 Group', 'Red SAM AAA 2', 'Baluza HQ', 'Red SAM SHORAD SA-15 Group', 'Red SAM SHORAD SA-8 Group 2'}
	},
	startbase = {
		blue = {'blueInfantry'},
		red = {'Ground Forces 2', 'Red SAM AAA','Red SAM SHORAD SA-15 Group 2', 'Red SAM SHORAD SA-8 Group 2','Red SAM AAA 2', 'Ground Armour 2', 'Ground Armour 3', 'Red SAM SHORAD SA-15 Group', 'Red SAM SHORAD SA-8 Group'}
	},
	startbase2 = {
		blue = {'blueInfantry', 'blueArmor'},
		red = {'Ground Forces 2', 'Ground Armour', 'Ground Armour 3', 'Red SAM AAA 2','Red SAM SHORAD SA-15 Group 2', 'Red SAM AAA', 'Red SAM SHORAD SA-15 Group', 'Red SAM SHORAD SA-8 Group'}
	},

	sam1bravo = {
        blue = {'bluePD1', 'BLUE SAM Fixed NASAMS Bravo'},
        red = {'Red SAM AAA Fixed Bravo - 1', 'Red SAM AAA Fixed Bravo - 2', 'Red SAM SHORAD SA-8 Fixed Bravo - 1', 'Red SAM SHORAD SA-8 Fixed Bravo - 2', 'Red SAM SA-2 Fixed Bravo'}
    },
	sam1delta = {
        blue = {'bluePD1', 'BLUE SAM Fixed NASAMS Delta'},
        red = {'Red SAM AAA Fixed Delta - 1', 'Red SAM AAA Fixed Delta - 2', 'Red SAM SHORAD SA-15 Fixed Delta - 1', 'Red SAM SHORAD SA-15 Fixed Delta - 2', 'Red SAM Fixed SA-2 Delta'}
    },

	  sam2echo = {
        blue = {'bluePD2', 'BLUE SAM Fixed NASAMS Echo'},
        red = {'Red SAM AAA Fixed Echo', 'Red SAM SHORAD SA-19 Fixed Echo - 1', 'Red SAM SHORAD SA-19 Fixed Echo - 2' ,'Red SAM SHORAD SA-19 Fixed Echo - 3', 'Red SAM SA-3 Fixed Echo'}
    },

	  sam3alpha = {
        blue = {'bluePD1', 'BLUE SAM Fixed Hawk Alpha'},
        red = {'Red SAM SHORAD Fixed Alpha', 'Red SAM SA-6 Fixed Alpha'}
    },
	 sam3foxtrot = {
        blue = {'bluePD1', 'BLUE SAM Fixed HAWK Foxtrot'},
        red = {'Red SAM AAA Fixed Foxtrot', 'Red SAM SHORAD SA-15 Fixed Foxtrot - 1', 'Red SAM SHORAD SA-15 Fixed Foxtrot - 2', 'Red SAM SA-6 Fixed Foxtrot'}
    },
    sam4hotel = {
        blue = {'bluePD2', 'BLUE SAM Fixed HAWK Hotel'},
        red = {'Red SAM AAA Fixed Hotel', 'Red SAM SHORAD SA-15 Fixed Hotel - 1', 'Red SAM SHORAD SA-15 Fixed Hotel - 2', 'Red SAM SA-10 Fixed Hotel'}
    },
    sam4golf = {
        blue = {'bluePD2', 'BLUE SAM Fixed HAWK Golf'},
        red = {'Red SAM AAA Fixed', 'Red SAM SHORAD SA-15 Fixed Golf - 1', 'Red SAM SHORAD SA-15 Fixed Golf - 2', 'Red SAM SA-10 Fixed Golf'}
    },
    sam4echo = {
        blue = {'bluePD2', 'BLUE SAM Fixed HAWK Echo'},
        red = {'Red SAM AAA Fixed Echo', 'Red SAM SHORAD SA-19 Fixed Echo', 'Red SAM Fixed SA-10 Echo'}
    },
    sam5juliett = {
        blue = {},
        red = {'Red SAM SHORAD Fixed Juliett', 'Red SAM SA-11 Fixed Juliett'}
    },
	 sam5missileFactory = {
        blue = {'bluePD1', 'bluePATRIOT'},
        red = {'Red SAM SHORAD Fixed Missile Factory', 'Red SAM SA-11 Fixed Missile Factory', 'Fixed-Scuds'}
    },
    sam5Charlie = {
        blue = {'bluePD1', 'BLUE SAM Fixed PATRIOT Charlie'},
        red = {'Red SAM AAA Fixed Charlie', 'Red SAM SHORAD SA-8 Fixed Charlie - 1', 'Red SAM SHORAD SA-8 Fixed Charlie - 2', 'Red SAM SA-11 Fixed Charlie'}
    },
    sam6india = {
        blue = {},
        red = {'Red SAM SHORAD SA-8 Fixed India', 'Red SAM SHORAD SA-15 Fixed India', 'Red SAM Fixed SA-5 India'}
	},
	farp1 = {
		blue = {'blueInfantry', 'blueArmor', 'bluePD1'},
		red = {'Ground Forces 1', 'Red SAM SHORAD SA-8 Group 2', 'Ground Armour', 'Ground Armour 3', 'Red SAM SHORAD SA-8 Group'}
	},
	Alpha = {
		blue = {'blueInfantry', 'blueArmor', 'bluePD1'},
		red = {'Alpha Container', 'Alpha Fuel Tank', 'Alpha Fuel Tank 2', 'Red SAM AAA 2', 'Red SAM SHORAD SA-8 Group 2', 'Ground Forces 1', 'Red SAM AAA', 'Ground Armour', 'Ground Armour 3', 'Red SAM SHORAD SA-8 Group'}
	},
	farp2 = {
		blue = {'blueInfantry', 'blueArmor', 'bluePD1'},
		red = {'Ground Forces 1', 'Red SAM AAA', 'Ground Armour', 'Ground Armour 3', 'Red SAM SHORAD SA-19 Group', 'Red SAM AAA 2', 'Red SAM SHORAD SA-19 Group 2'}
	},
	farp3 = {
		blue = {'blueInfantry', 'blueArmor', 'bluePD2'},
		red = {'Ground Forces 2', 'Red SAM AAA', 'Red SAM SHORAD SA-15 Group 2', 'Ground Armour 2', 'Ground Armour 3', 'Red SAM AAA 2', 'Red SAM SHORAD SA-15 Group'}
	},
	farp32 = {
		blue = {'blueInfantry', 'blueArmor', 'bluePD2'},
		red = {'Ground Forces 2', 'Red SAM AAA', 'Red SAM SHORAD SA-15 Group 2', 'Ground Armour 2', 'Ground Armour 3', 'Red SAM AAA 2', 'Red SAM SHORAD SA-15 Group'}
	},
	Charlie = {
		blue = {'blueInfantry', 'blueArmor', 'bluePD2'},
		red = {'Ground Forces 2','Red SAM AAA', 'Charlie supplies 2', 'Red SAM SHORAD SA-8 Group 2', 'Red SAM AAA 2', 'Ground Armour 2', 'Ground Armour 3', 'Charlie supplies', 'Red SAM SHORAD SA-8 Group'}
	},
	mission1 = {
		blue = {'blueInfantry', 'blueArmor'},
		red = {'Red SAM SA-3 Fixed Mining', 'Ground Armour Fixed Mining', 'Mining Facility outpost', 'Red SAM AAA Fixed Mining', 'Red SAM SHORAD SA-19 Fixed MiningFacility', 
	'Mining Facility Command Center'}
	},
	
	mission1Ammo = {
		blue = {'blueInfantry', 'blueArmor'},
		red = {'Scuds Ammunition Depo Fixed', 'Ammunition Depo','Ammunition Depo 2', 'Red SAM SHORAD SA-15 Fixed Ammunition Depo','Ammunition Depo 3', 'Ammunition Depo Storage', 'T-80 Ammunition Depo Fixed', 'Ammo Trucks Ammunition Depo', 'Red SAM AAA Ammunition Depo Fixed'}
	},
	
	TankFactory = {
		blue = {'blueInfantry', 'blueArmor'},
		red = {'Tank Factory T-90', 'Red SAM SA-6 TankFactory 2 Fixed', 'Red SAM SA-6 TankFactory Fixed', 'Red SAM AAA Fixed TankFactory', 'Tank factory HQ', 'Tank Factory', 'Tank Factory outpost', 
		'Tank Factory Troops garage', 'Tank Factory Command Center', }
	},
	mission2InsurgentCamp = {
		blue = {'blueInfantry', 'blueArmor'},
		red = {'Fixed-InfantryGroup', 'Insurgent camp tent', 'Insurgent camp storage', 'Fixed-InfantryGroup-2', 'Insurgent camp tent 2', 'Insurgent camp outpost', 'Fixed-Zu23', 'Fixed-Art'}
	
	},
	mission3 = {
		blue = {'blueInfantry', 'blueArmor'},
		red = {'Red SAM SA-6 Fixed Secret tech', 'Red SAM SHORAD SA-15 Fixed Secret tech', 'Fixed-redArmor2', 'Fixed-redArmor1', 'Fixed-redInfantry2', 'Secret Tech Bulding', 'Secret Tech Bulding 2', 'Secret Tech Command Center', 'Secret Tech building HQ', 'Secret Tech Factory'}
			  
	},

	mission3chemsite = {
		blue = {'blueInfantry', 'blueArmor'},
		red = {'Chemsite Infantry Group Fixed', 'Chemsite Armoured group Fixed', 'Chemsite Armoured group Fixed 2', 'Red SAM SHORAD SA-15 Fixed ChemSite', 'Chemical Tank 1', 'Chemical Tank 2', 'Chemical Tank 3',
		'Chemical Tank 4', 'Chemical Factory 1', 'Chemical Factory 2', 'Chemical Factory 3', 'Chemical Factory 4'}
	},
	mission4 = {
		blue = {'blueInfantry', 'blueArmor'},
		red = {'Ground Forces 2', 'Artilliary MRL FDDM Fixed', 'Artillery Factory building', 'Ground Armour 2','Artilliary 9K57 Uragan Fixed', 'Red SAM SHORAD SA-8 Group', 'Artilliary MLRS 9A52 Smerch Fixed'}
	},
	
	mission4fueldepo = {
		blue = {'blueInfantry', 'blueArmor'},
		red = {'FuelDepo fuel tank', 'FuelDepo fuel tank 2', 'Red SAM AAA Fuel', 'FuelDepo fuel tank 3', 'FuelDepo fuel tank 4', 'FuelDepo fuel tank 5', 'Red SAM SHORAD SA-19 Fixed-Fuel3', 'Red SAM SHORAD SA-15 Fixed-Fuel4', 'FuelDepo fuel tank 6', 'Pump station', 'Pump station 2', 'Pump station 3'}
	},
	portsaidFixed = {
		blue = {},
		red = {'Fixed-redInfantry Port Said', 'Fixed-redArmor Port Said_1', 'Red SAM SHORAD SA-15 Fixed Port Said', 'Red SAM SA-6 Fixed Port Said', 'Fixed-redArmor Port Said', 'Naval-Group-Fixed-PortSaid'}
	},
	borjoilFixed = {
		blue = {},
		red = {'Red SAM SA-6 Fixed Borj Oil production', 'Red SAM SHORAD SA-15 Fixed Borj Oil production', 'Fixed-redInfantry Borj Oil production-1', 
		'Fixed-redInfantry Borj Oil production', 'Borj Oil production 4', 'Borj Oil production 3', 'Borj Oil production 2', 'Borj Oil production 1', 
		'Borj Oil production 5', 'Borj Oil production 6'}
	
	},
	HiddenFixed_Disabled = {
		blue = {},
		red = {'Red EWR Ramon Airbase Fixed', 'Red EWR Tech Fixed', 'Red EWR Bir Hasnah Fixed', 'Red EWR Cairo Fixed', 
		'Red EWR FARP Hotel Fixed', 'Red EWR Juliett-Mike Fixed', 'Red SAM SA-3 Fixed Hidden1', 'Red SAM SA-3 Fixed Hidden2', 
		'Red SAM SA-3 Fixed Hidden3', 'Red SAM SA-3 Fixed Hidden4', 'Red SAM SA-6 Fixed Hidden5', 'Red SAM SA-6 Fixed Hidden6', 
		'Red SAM SA-6 Fixed Hidden7', 'Red SAM SA-6 Fixed Hidden8', 'Red SAM SA-6 Fixed Hidden9'}
	},
	HiddenFixed = {
		blue = {},
		red = {'Red EWR Ramon Airbase Fixed', 'Red EWR Tech Fixed', 'Red EWR Bir Hasnah Fixed', 'Red EWR Cairo Fixed', 
				'Red EWR FARP Hotel Fixed', 'Red EWR Juliett-Mike Fixed', 'HQ Fixed'}
	}
}

flavor = {
	bluecarrier = 'WPT \nStart zone',
	redcarrier = 'WPT 15\nEnemy carrier zone',
	sdedov = 'WPT \n',
	bengurion = 'WPT 1\n',
	palmahim = 'WPT \n',
	telnof = 'WPT \n',
	hatzor = 'WPT 2\n',
	kedemhatzerim = 'WPT 3\n',
	nevatim = 'WPT 4\n',
	ramonairbase = 'WPT 5\n',
	elgora = 'WPT 9\n',
	elarish = 'WPT 10\n',
	ovda = 'WPT 7\n',
	birhasanah = 'WPT 13\n',
	melez = 'WPT 12\n',
	baluza = 'WPT 14\n',
	assalihiyah = 'WPT 16\n',
	alismailiyah = 'WPT 17\n',
	kibritairbase = 'WPT 18\n',
	almansurah = 'WPT 23\n',
	azzaqaziq = 'WPT 22\n',
	inshasairbase = 'WPT 21\n',
	cairointernationalairport = 'WPT 20\n',
	wadialjandali = 'WPT 19\n',
	cairowest = 'WPT 28\n',
	benisuef = 'WPT 30\n',
	gebelelbasur = 'WPT 27\n',
	komawshim = 'WPT 29\n',
	birmaairbase = 'WPT 24\n',
	farpalpha = 'WPT 6\n',
	farpbravo = 'WPT 8\n',
	farpcharlie = 'WPT 11\n',
	
	miningfacility = 'Check kneeboard for coordinates.\n',
	insurgentcamp = 'Check kneeboard for coordinates.\nDestroy the Insurgents and we will add to your bank 500 credits',
	secrettechfacility = 'Check kneeboard for coordinates.\nDestroy the buildings and area completly',
	fueldepo = 'Check kneeboard for coordinates.\nTake out their Fuel Depo including the fuel tanks',
	ammonitiondepo = 'Check kneeboard for coordinates.\nTake out their ammunition Depo including the storage',
	tankfactory = 'Check kneeboard for coordinates.\nDestroy the factorys and the tank storage',
	chemsite = 'Check kneeboard for coordinates.\nHere they are building chemical weapons. Destroy the buildings',
	artilleryfactory = 'Check kneeboard for coordinates.\n',
	missilefactory = 'Check kneeboard for coordinates.\nRumors say they have Scuds here',
	portsaid = 'Check kneeboard for coordinates.\nDestroy the port',
	borjoil = 'Check kneeboard for coordinates.\nDestroy the militant target in that area.',
	
	
	
	samalpha = 'Check kneeboard for coordinates.\nFriendly SAM',
	sambravo = 'Check kneeboard for coordinates.\nSA-2 and Red SAM SHORAD',
	samcharlie = 'Check kneeboard for coordinates.\nSA-11 and Red SAM SHORAD',
	samdelta = 'Check kneeboard for coordinates.\nSA-2 and Red SAM SHORAD',
	samecho = 'Check kneeboard for coordinates.\nSA-3 and Red SAM SHORAD',
	samfoxtrot = 'Check kneeboard for coordinates.\nSA-6 and Red SAM SHORAD',
	samgolf = 'Check kneeboard for coordinates.\nSA-10 and Red SAM SHORAD',
	samhotel = 'Check kneeboard for coordinates.\nSA-10 and Red SAM SHORAD',
	samindia = 'Check kneeboard for coordinates.\nSA-5 and Red SAM SHORAD',
	Juliett = 'Check kneeboard for coordinates.\nSA-10 and Red SAM SHORAD'

}

WaypointList = {
    ["Ben-Gurion"] = ' (1)',
    Hatzor = ' (2)',
    ["Kedem-Hatzerim"] = ' (3)',
    Nevatim = ' (4)',
    ["Ramon Airbase"] = ' (5)',
    ["FARP-Alpha"] = ' (6)',
    Ovda = ' (7)',
    ["FARP-Bravo"] = ' (8)',
    ["El Gora"] = ' (9)',
    ["El Arish"] = ' (10)',
    ["FARP-Charlie"] = ' (11)',
    Melez = ' (12)',
    ["Bir Hasanah"] = ' (13)',
    Baluza = ' (14)',
    ["Red Carrier"] = ' (15)',
    ["As Salihiyah"] = ' (16)',
    ["Al Ismailiyah"] = ' (17)',
    ["Kibrit Air Base"] = ' (18)',
    ["Wadi al Jandali"] = ' (19)',
    ["Cairo International Airport"] = ' (20)',
    ["Inshas Airbase"] = ' (21)',
    ["AzZaqaziq"] = ' (22)',
    ["Al Mansurah"] = ' (23)',
    ["Birma Air Base"] = ' (24)',
    ["Jiyanklis Air Base"] = ' (25)',
    ["Borg El Arab International Airport"] = ' (26)',
    ["Gebel El Basur Air Base"] = ' (27)',
    ["Cairo West"] = ' (28)',
    ["Kom Awshim"] = ' (29)',
    ["Beni Suef"] = ' (30)',
}

local filepath = 'FootHold_SI_North_v0.1.lua'
if lfs then 
	local dir = lfs.writedir()..'Missions/Saves/'
	lfs.mkdir(dir)
	filepath = dir..filepath
	env.info('Foothold - Save file path: '..filepath)
end
bc = BattleCommander:new(filepath, 10, 60)
zones = {
	redcarrier = ZoneCommander:new({zone='Red Carrier', side=1, level=10, upgrades=upgrades.redships, crates={}, flavorText=flavor.redcarrier}),
	bluecarrier = ZoneCommander:new({zone='Blue Carrier', side=2, level=1, upgrades=upgrades.blueships, crates={}, flavorText=flavor.bluecarrier}),
	
	sdedov = ZoneCommander:new({zone='Sde Dov', side=2, level=2, upgrades=upgrades.startbase2, crates={}, flavorText=flavor.sdedov}),
	bengurion = ZoneCommander:new({zone='Ben-Gurion', side=2, level=1, upgrades=upgrades.airfieldBen, crates={}, flavorText=flavor.bengurion}),
	palmahim = ZoneCommander:new({zone='Palmahim', side=2, level=1, upgrades=upgrades.startbase, crates={}, flavorText=flavor.palmahim}),
	telnof = ZoneCommander:new({zone='Tel Nof', side=2, level=1, upgrades=upgrades.startbase, crates={}, flavorText=flavor.telnof}),
	hatzor = ZoneCommander:new({zone='Hatzor', side=2, level=1, upgrades=upgrades.startbase, crates={}, flavorText=flavor.hatzor}),
	kedemhatzerim = ZoneCommander:new({zone='Kedem-Hatzerim', side=1, level=20, upgrades=upgrades.airfield2hat, crates={}, flavorText=flavor.kedemhatzerim}),
	nevatim = ZoneCommander:new({zone='Nevatim', side=1, level=20, upgrades=upgrades.airfield3nevatim, crates={}, flavorText=flavor.nevatim}),
	ramonairbase = ZoneCommander:new({zone='Ramon Airbase', side=1, level=20, upgrades=upgrades.RamonAirbase, crates={}, flavorText=flavor.ramonairbase}),
	elgora = ZoneCommander:new({zone='El Gora', side=1, level=20, upgrades=upgrades.ElGoraUpgrade, crates={}, flavorText=flavor.elgora}),
	elarish = ZoneCommander:new({zone='El Arish', side=1, level=20, upgrades=upgrades.airfield2, crates={}, flavorText=flavor.elarish}),
	ovda = ZoneCommander:new({zone='Ovda', side=1, level=20, upgrades=upgrades.airfield3, crates={}, flavorText=flavor.ovda}),
	birhasanah = ZoneCommander:new({zone='Bir Hasanah', side=0, level=2, upgrades=upgrades.airfield2, crates={}, flavorText=flavor.birhasanah, NeutralAtStart=true}),
	melez = ZoneCommander:new({zone='Melez', side=1, level=20, upgrades=upgrades.Melez, crates={}, flavorText=flavor.melez}),
	baluza = ZoneCommander:new({zone='Baluza', side=0, level=2, upgrades=upgrades.Baluza, crates={}, flavorText=flavor.baluza, NeutralAtStart=true}),
	assalihiyah = ZoneCommander:new({zone='As Salihiyah', side=0, level=2, upgrades=upgrades.airfield1, crates={}, flavorText=flavor.assalihiyah, NeutralAtStart=true}),
	alismailiyah = ZoneCommander:new({zone='Al Ismailiyah', side=0, level=10, upgrades=upgrades.airfield2Ismailiyah, crates={}, flavorText=flavor.alismailiyah, NeutralAtStart=true}),
	kibritairbase = ZoneCommander:new({zone='Kibrit Air Base', side=1, level=20, upgrades=upgrades.airfield2, crates={}, flavorText=flavor.kibritairbase}),
	almansurah = ZoneCommander:new({zone='Al Mansurah', side=0, level=1, upgrades=upgrades.airfield3, crates={}, flavorText=flavor.almansurah, NeutralAtStart=true}),
	azzaqaziq = ZoneCommander:new({zone='AzZaqaziq', side=0, level=1, upgrades=upgrades.airfield4, crates={}, flavorText=flavor.azzaqaziq, NeutralAtStart=true}),
	inshasairbase = ZoneCommander:new({zone='Inshas Airbase', side=0, level=1, upgrades=upgrades.airfield2, crates={}, flavorText=flavor.inshasairbase, NeutralAtStart=true}),
	cairointernationalairport = ZoneCommander:new({zone='Cairo International Airport', side=0, level=1, upgrades=upgrades.airfield3, crates={}, flavorText=flavor.cairointernationalairport, NeutralAtStart=true}),
	wadialjandali = ZoneCommander:new({zone='Wadi al Jandali', side=0, level=20, upgrades=upgrades.Wadi, crates={}, flavorText=flavor.wadialjandali, NeutralAtStart=true}),
	cairowest = ZoneCommander:new({zone='Cairo West', side=0, level=1, upgrades=upgrades.airfield4, crates={}, flavorText=flavor.cairowest, NeutralAtStart=true}),
	benisuef = ZoneCommander:new({zone='Beni Suef', side=0, level=1, upgrades=upgrades.airfield4, crates={}, flavorText=flavor.benisuef, NeutralAtStart=true}),
	komawshim = ZoneCommander:new({zone='Kom Awshim', side=0, level=1, upgrades=upgrades.farp2, crates={}, flavorText=flavor.komawshim, NeutralAtStart=true}),
	gebelelbasur = ZoneCommander:new({zone='Gebel El Basur Air Base', side=0, level=1, upgrades=upgrades.farp32, crates={}, flavorText=flavor.gebelelbasur, NeutralAtStart=true}),
	birmaairbase = ZoneCommander:new({zone='Birma Air Base', side=0, level=1, upgrades=upgrades.farp3, crates={}, flavorText=flavor.birmaairbase, NeutralAtStart=true}),
	jiyanklisairbase = ZoneCommander:new({zone='Jiyanklis Air Base', side=0, level=6, upgrades=upgrades.farp3, crates={}, flavorText=flavor.jiyanklisairbase, NeutralAtStart=true}),
	borgelarab = ZoneCommander:new({zone='Borg El Arab International Airport', side=0, level=1, upgrades=upgrades.farp3, crates={}, flavorText=flavor.borgelarab, NeutralAtStart=true}),
	
	farpalpha = ZoneCommander:new({zone='FARP-Alpha', side=1, level=20, upgrades=upgrades.Alpha, crates={}, flavorText=flavor.farpalpha}),
	farpbravo = ZoneCommander:new({zone='FARP-Bravo', side=0, level=10, upgrades=upgrades.farp3, crates={}, flavorText=flavor.farpbravo, NeutralAtStart=true}),
	farpcharlie = ZoneCommander:new({zone='FARP-Charlie', side=0, level=6, upgrades=upgrades.Charlie, crates={}, flavorText=flavor.farpcharlie, NeutralAtStart=true}),
	
	
	miningfacility = ZoneCommander:new({zone='MiningFacility', side=1, level=20, upgrades=upgrades.mission1, crates={}, flavorText=flavor.miningfacility}),
	insurgentcamp = ZoneCommander:new({zone='InsurgentCamp', side=1, level=25, upgrades=upgrades.mission2InsurgentCamp, crates={}, flavorText=flavor.insurgentcamp}),
	secrettechfacility = ZoneCommander:new({zone='SecretTechFacility', side=1, level=25, upgrades=upgrades.mission3, crates={}, flavorText=flavor.secrettechfacility}),
	fueldepo = ZoneCommander:new({zone='FuelDepo', side=1, level=25, upgrades=upgrades.mission4fueldepo, crates={}, flavorText=flavor.fueldepo}),
	ammonitiondepo = ZoneCommander:new({zone='AmmonitionDepo', side=1, level=20, upgrades=upgrades.mission1Ammo, crates={}, flavorText=flavor.ammonitiondepo}),
	tankfactory = ZoneCommander:new({zone='TankFactory', side=1, level=20, upgrades=upgrades.TankFactory, crates={}, flavorText=flavor.tankfactory}),
	chemsite = ZoneCommander:new({zone='ChemSite', side=1, level=25, upgrades=upgrades.mission3chemsite, crates={}, flavorText=flavor.chemsite}),
	artilleryfactory = ZoneCommander:new({zone='ArtilleryFactory', side=1, level=20, upgrades=upgrades.mission4, crates={}, flavorText=flavor.artilleryfactory}),
	missilefactory = ZoneCommander:new({zone='MissileFactory', side=1, level=20, upgrades=upgrades.sam5missileFactory, crates={}, flavorText=flavor.missilefactory}),
	portsaid = ZoneCommander:new({zone='Port Said', side=1, level=20, upgrades=upgrades.portsaidFixed, crates={}, flavorText=flavor.portsaid}),
	borjoil = ZoneCommander:new({zone='Borj Oil production Site', side=1, level=20, upgrades=upgrades.borjoilFixed, crates={}, flavorText=flavor.borjoil}),
	
	hidden1 = ZoneCommander:new({zone='Hidden1', side=1, level=15, upgrades=upgrades.HiddenFixed, crates={}, flavorText=flavor.hidden1}),

	
	
	samalpha = ZoneCommander:new({zone='SAM-Alpha', side=2, level=5, upgrades=upgrades.sam3alpha, crates={}, flavorText=flavor.samalpha}),
	sambravo = ZoneCommander:new({zone='SAM-Bravo', side=1, level=5, upgrades=upgrades.sam1bravo, crates={}, flavorText=flavor.sambravo}),
	samcharlie = ZoneCommander:new({zone='SAM-Charlie', side=1, level=5, upgrades=upgrades.sam5Charlie, crates={}, flavorText=flavor.samcharlie}),
	samdelta = ZoneCommander:new({zone='SAM-Delta', side=1, level=5, upgrades=upgrades.sam1delta, crates={}, flavorText=flavor.samdelta}),
	samecho = ZoneCommander:new({zone='SAM-Echo', side=1, level=5, upgrades=upgrades.sam2echo, crates={}, flavorText=flavor.samecho}),
	samfoxtrot = ZoneCommander:new({zone='SAM-Foxtrot', side=1, level=5, upgrades=upgrades.sam3foxtrot, crates={}, flavorText=flavor.samfoxtrot}),
	samhotel = ZoneCommander:new({zone='SAM-Hotel', side=1, level=5, upgrades=upgrades.sam4hotel, crates={}, flavorText=flavor.samhotel, NeutralAtStart=true}),
	samgolf = ZoneCommander:new({zone='SAM-Golf', side=1, level=5, upgrades=upgrades.sam4golf, crates={}, flavorText=flavor.samgolf}),
	samindia = ZoneCommander:new({zone='SAM-India', side=0, level=5, upgrades=upgrades.sam6india, crates={}, flavorText=flavor.samindia, NeutralAtStart=true}),
	samjuliett = ZoneCommander:new({zone='SAM-Juliett', side=1, level=5, upgrades=upgrades.sam5juliett, crates={}, flavorText=flavor.samjuliett}),

}

zones.hatzor:addGroups({
    GroupCommander:new({name = 'Hatzor-Attack-Kedem-blue', mission = 'attack', targetzone = 'Kedem-Hatzerim'}),
    GroupCommander:new({name = 'Hatzor-Support-Kedem-blue', mission = 'supply', targetzone = 'Kedem-Hatzerim'}),
    GroupCommander:new({name = 'Hatzor-Support-SAM-Alpha-blue', mission = 'supply', targetzone = 'SAM-Alpha'})
})
zones.elgora:addGroups({
    GroupCommander:new({name = 'El-Gora-Support-El-Arish-blue', mission = 'supply', targetzone = 'El Arish'})
})
zones.farpalpha:addGroups({
    GroupCommander:new({name = 'Farp-Alpha-Supply-FARP-Bravo-blue', mission = 'supply', targetzone = 'FARP-Bravo'}),
    GroupCommander:new({name = 'Farp-Alpha-Supply-Ovda-blue', mission = 'supply', targetzone = 'Ovda'})
})

zones.farpcharlie:addGroups({
    GroupCommander:new({name = 'Farp-Charlie-Supply-Baluza-blue', mission = 'supply', targetzone = 'Baluza'}),
    GroupCommander:new({name = 'Farp-Charlie-supply-Melez', mission = 'supply', targetzone = 'Melez'}),
	GroupCommander:new({name = 'Farp-Charlie-Supply-Melez-blue', mission = 'supply', targetzone = 'Melez'})
})

zones.kedemhatzerim:addGroups({
	GroupCommander:new({name = 'Kedem-Support-Nevatim-blue', mission = 'supply', targetzone = 'Nevatim'}),
	GroupCommander:new({name = 'Kadem-supprt-Ramon-blue', mission = 'supply', targetzone = 'Ramon Airbase'}),
    GroupCommander:new({name = 'Kedem-Support-El Gora-blue', mission = 'supply', targetzone = 'El Gora'}),
    GroupCommander:new({name = 'Kadem-supprt-Nevatim-blue', mission = 'supply', targetzone = 'Nevatim'}),
	GroupCommander:new({name = 'Kedem-Support-Ramon-blue', mission = 'supply', targetzone = 'Ramon Airbase'}),
    GroupCommander:new({name = 'Hatzerim-Attack-Hatzor', mission = 'attack', targetzone = 'Hatzor'}),
    GroupCommander:new({name = 'Hatzerim-Support-Hatzor', mission = 'supply', targetzone = 'Hatzor'})   
})
zones.birhasanah:addGroups({
    GroupCommander:new({name = 'Bir-Hasanah-Support-SAM-Charlie-Blue', mission = 'supply', targetzone = 'SAM-Charlie'})
})
zones.ramonairbase:addGroups({
    GroupCommander:new({name = 'Ramon-Attack-Hatzor', mission = 'attack', targetzone = 'Hatzor'}),
    GroupCommander:new({name = 'Ramon-Attack-Kedem', mission = 'attack', targetzone = 'Kedem-Hatzerim'}),
    GroupCommander:new({name = 'Ramon-Supply-Kedem', mission = 'supply', targetzone = 'Kedem-Hatzerim', condition = function() return zones.melez.side == 1 end}),
    GroupCommander:new({name = 'Ramon-Supply-Nevatim', mission = 'supply', targetzone = 'Nevatim', condition = function() return zones.melez.side == 1 end}),
    GroupCommander:new({name = 'Ramon-Supply-El Gora', mission = 'supply', targetzone = 'El Gora', condition = function() return zones.melez.side == 1 end}),
    GroupCommander:new({name = 'Ramon-Supply-SAM-Bravo', mission = 'supply', targetzone = 'SAM-Bravo', condition = function() return zones.melez.side == 1 end}),
    GroupCommander:new({name = 'Ramon-Patrol-Kedem', mission = 'patrol', targetzone = 'Kedem-Hatzerim'}),
    GroupCommander:new({name = 'Ramon-Patrol-Kedem', mission = 'patrol', targetzone = 'Nevatim'}),
    GroupCommander:new({name = 'Ramon-Supply-Sam-Bravo-blue', mission = 'supply', targetzone = 'SAM-Bravo'}),
    GroupCommander:new({name = 'Ramon-Attack-Melez-blue', mission = 'attack', targetzone = 'Melez'}),
    GroupCommander:new({name = 'Ramon-Supply-Farp-Alpha-blue', mission = 'supply', targetzone = 'FARP-Alpha'}),
    GroupCommander:new({name = 'Ramon-Supply-El-Gora-blue', mission = 'supply', targetzone = 'El Gora'}),
    GroupCommander:new({name = 'Ramon-Patrol-Melez-Blue', mission = 'attack', targetzone = 'Melez'}),
	GroupCommander:new({name = 'Ramon-attack-Ovda-blue', mission = 'attack', targetzone = 'Ovda'})
})
zones.ovda:addGroups({
    GroupCommander:new({name = 'Ovda-Attack-Kedem', mission = 'attack', targetzone = 'Ramon Airbase', diceChance = 50}),
    GroupCommander:new({name = 'Ovda-Support-Ramon', mission = 'supply', targetzone = 'Ramon Airbase'}),
    GroupCommander:new({name = 'Ovda-Support-FARP-Alpha', mission = 'supply', targetzone = 'FARP-Alpha', condition = function() return zones.kedemhatzerim.wasBlue end, urgent = zones.farpalpha.side == 0}),
	GroupCommander:new({name = 'Ovda-Support-FARP-Bravo', mission = 'supply', targetzone = 'FARP-Bravo', condition = function() return zones.kedemhatzerim.wasBlue end, urgent = zones.farpbravo.side == 0}),
    GroupCommander:new({name = 'Ovda-Patrol-Ramon-Airbase', mission = 'patrol', targetzone = 'Ramon Airbase'})
}) 
zones.melez:addGroups({
	GroupCommander:new({name = 'Melez-Support-Bir-Hasanah', mission = 'supply', targetzone = 'Bir hasanah', type = 'surface', condition = function() return zones.ramonairbase.wasBlue end}),
	GroupCommander:new({name = 'Melez-Support-Sam-Delta', mission = 'supply', targetzone = 'SAM-Delta', type = 'surface'}),
	GroupCommander:new({name = 'Melez-Support-Nevrim', mission = 'supply', targetzone = 'Nevatim'}),
    GroupCommander:new({name = 'Melez-Support-Bir Hasanah', mission = 'supply', targetzone = 'Bir Hasanah', condition = function() return zones.ramonairbase.wasBlue end, urgent = zones.birhasanah.side == 0}),
    GroupCommander:new({name = 'Melez-Support-FARP-Charlie', mission = 'supply', targetzone = 'FARP-Charlie', condition = function() return zones.ramonairbase.wasBlue end, urgent = zones.farpcharlie.side == 0}),
    GroupCommander:new({name = 'Melez-Attack-Bir Hasanah', mission = 'attack', targetzone = 'Bir Hasanah'}),
    GroupCommander:new({name = 'Melez-Attack-FARP-Bravo', mission = 'attack', targetzone = 'FARP-Bravo'}),
    GroupCommander:new({name = 'Melez-Attack-FARP-Charlie', mission = 'attack', targetzone = 'FARP-Charlie'}),
    GroupCommander:new({name = 'Melez-Patrol-Bir Hasanah', mission = 'patrol', MissionType='CAP', targetzone = 'Bir Hasanah', condition = function() return zones.ramonairbase.wasBlue end}),
    GroupCommander:new({name = 'Melez-Attack-ramon-air-base', mission = 'attack', MissionType='CAP', targetzone = 'Ramon Airbase'}),
	GroupCommander:new({name = 'Melez-support-Bir-Hasanah-Blue', mission = 'supply', targetzone = 'Bir Hasanah'}),
    GroupCommander:new({name = 'Melez-support-FARP-Bravo-blue', mission = 'supply', targetzone = 'FARP-Bravo'}),
    GroupCommander:new({name = 'Melez-Support-Sam-Delta-blue', mission = 'supply', targetzone = 'SAM-Delta', type = 'surface'}),
    GroupCommander:new({name = 'Melez-Support-Al Ismailiyah-blue', mission = 'supply', targetzone = 'Al Ismailiyah'}),
	GroupCommander:new({name = 'Melez-Support-FARP-Charlie-Blue', mission = 'supply', targetzone = 'FARP-Charlie'}),
	GroupCommander:new({name = 'Melez-support-FARP-kibrit-air-base-blue', mission = 'supply', targetzone = 'Kibrit Air Base'}),
	GroupCommander:new({name = 'Melez-patrol-Melez-blue', mission = 'patrol', targetzone = ' Melez'})
})
zones.baluza:addGroups({
    GroupCommander:new({name = 'Baluza-Support-SAM-Echo', mission = 'supply', targetzone = 'SAM-Echo', condition = function() return zones.ramonairbase.wasBlue end}),
    GroupCommander:new({name = 'Baluza-Support-Melez', mission = 'supply', targetzone = 'Melez', condition = function() return zones.ramonairbase.wasBlue end}),
    GroupCommander:new({name = 'Baluza-Support-FARP-Charlie', mission = 'supply', targetzone = 'FARP-Charlie', condition = function() return zones.ramonairbase.wasBlue end}),
    GroupCommander:new({name = 'Baluza-Attack-El Arish', mission = 'attack', targetzone = 'El Arish', diceChance = 50}),
    GroupCommander:new({name = 'Baluza-Attack-Melez', mission = 'attack', targetzone = 'Melez', condition = function() return zones.ramonairbase.wasBlue end}),
    GroupCommander:new({name = 'Baluza-Support-As-Salihiyah-blue', mission = 'supply', targetzone = 'As Salihiyah'}),
	GroupCommander:new({name = 'Baluza-Support-SAM-Echo-blue', mission = 'supply', targetzone = 'SAM-Echo'})
})

zones.elarish:addGroups({
    GroupCommander:new({name = 'El-Arish-Patrol-Melez-blue', mission = 'patrol', targetzone = 'Melez'}),
    GroupCommander:new({name = 'El-Arish-support-FARP-Charlie-blue', mission = 'supply', targetzone = 'FARP-Charlie'}),
    GroupCommander:new({name = 'El-Arish-Supply-El-Gorah', mission = 'supply', targetzone = 'El Gora'})
})
zones.almansurah:addGroups({
    GroupCommander:new({name = 'Al Mansurah-Support-Al Salihiyah', mission = 'supply', targetzone = 'Al Salihiyah'}),
    GroupCommander:new({name = 'Al Mansurah-Support-SAM-Hotel', mission = 'supply', targetzone = 'SAM-Hotel'}),
    GroupCommander:new({name = 'Al Mansurah-Support-AzZaqaziq', mission = 'supply', targetzone = 'AzZaqaziq'}),
    GroupCommander:new({name = 'Al Mansurah-Support-SAM-Hotel-blue', mission = 'supply', targetzone = 'SAM-Hotel'}),
    GroupCommander:new({name = 'Al Mansurah-Support-Birma-Air-Base', mission = 'supply', targetzone = 'Birma Air Base', condition = function() return zones.assalihiyah.wasBlue end, urgent = zones.birmaairbase.side == 0}),
    GroupCommander:new({name = 'Al Mansurah-Support-Birma-Air-Base-Blue', mission = 'supply', targetzone = 'Birma Air Base'})
})
zones.azzaqaziq:addGroups({
    GroupCommander:new({name = 'AzZaqaziq-Patrol-Red Carrier', mission = 'patrol', targetzone = 'Red Carrier'}),
    GroupCommander:new({name = 'AzZaqaziq-Support-As Salihiyah', mission = 'supply', targetzone = 'As Salihiyah'}),
    GroupCommander:new({name = 'AzZaqaziq-Support-Al Ismailiyah', mission = 'supply', targetzone = 'Al Ismailiyah'}),
    GroupCommander:new({name = 'AzZaqaziq-Support-Kibrit', mission = 'supply', targetzone = 'Kibrit Air Base'}),
    GroupCommander:new({name = 'AzZaqaziq-Attack-As Salihiyah', mission = 'attack', targetzone = 'As Salihiyah'}),
    GroupCommander:new({name = 'AzZaqaziq-Attack-Al Ismailiyah', mission = 'attack', targetzone = 'Al Ismailiyah'}),
	GroupCommander:new({name = 'AzZaqaziq-attack-Melez', mission = 'attack', MissionType='CAP', targetzone = 'Melez'}),
    GroupCommander:new({name = 'azzaqaziq-Supply-Al-Mansurah-Blue', mission = 'supply', targetzone = 'Al Mansurah'}),
	GroupCommander:new({name = 'AzZaqaziq-Supply-Al-Mansurah', mission = 'supply', targetzone = 'Al Mansurah', urgent = zones.almansurah.side == 0}),
    GroupCommander:new({name = 'AzZaqaziq-Supply-gebelelbasur-Blue', mission = 'supply', targetzone = 'Gebel El Basur Air Base'}),
    GroupCommander:new({name = 'AzZaqaziq-Supply-Inshas Airbase-blue', mission = 'supply', targetzone = 'Inshas Airbase'}),
    GroupCommander:new({name = 'AzZaqaziq-Supply-Inshas Airbase', mission = 'supply', targetzone = 'Inshas Airbase', urgent = zones.inshasairbase.side == 0}),
    GroupCommander:new({name = 'AzZaqaziq-Supply-gebelelbasur', mission = 'supply', targetzone = 'Gebel El Basur Air Base', condition = function() return zones.assalihiyah.wasBlue or zones.wadialjandali.wasBlue end, urgent = zones.gebelelbasur.side == 0})
})
zones.wadialjandali:addGroups({
    GroupCommander:new({name = 'Wadi-Support-Beni-Suef-Blue', mission = 'supply', targetzone = 'Beni Suef'}),
	GroupCommander:new({name = 'Wadi-Support-Bilbeis-Kom-Awshim-Blue', mission = 'supply', targetzone = 'Kom Awshim'}),
	GroupCommander:new({name = 'Wadi-Support-Bilbeis-Inshas Airbase-blue', mission = 'supply', targetzone = 'Inshas Airbase'}),
	GroupCommander:new({name = 'Wadi-Support-Cairo-International-Airport-blue', mission = 'supply', targetzone = 'Cairo International Airport'}),
	GroupCommander:new({name = 'Wadi-Attack-kibrit-air-base', mission = 'attack', targetzone = 'Kibrit Air Base', type = 'surface'}),
    GroupCommander:new({name = 'Wadi-Attack-Baluza', mission = 'attack', targetzone = 'Baluza'}),
    GroupCommander:new({name = 'Wadi-al-jandali-support-Sam-Golf-blue', mission = 'supply', targetzone = 'SAM-Golf', type = 'surface'}),
    GroupCommander:new({name = 'Wadi-al-jandali-support-Sam-Golf', mission = 'supply', targetzone = 'SAM-Golf', type = 'surface', condition = function() return zones.melez.wasBlue end}),  
	GroupCommander:new({name = 'Wadi-Support-Kom-Awshim', mission = 'supply', targetzone = 'Kom Awshim', condition = function() return zones.alismailiyah.wasBlue or zones.kibritairbase.wasBlue end, urgent = zones.komawshim.side == 0}),
	GroupCommander:new({name = 'Wadi-Support-cairo-international-airport', mission = 'supply', targetzone = 'Cairo International Airport', condition = function() return zones.kibritairbase.wasBlue end, urgent = zones.cairointernationalairport.side == 0})
})
zones.kibritairbase:addGroups({
	GroupCommander:new({name = 'Kibrit-Air-Base-attack-Melez', mission = 'attack', MissionType='CAP', targetzone = 'Melez'}),
	GroupCommander:new({name = 'Kibrit-Air-Base-Support-Wadi-Al-Jandali', mission = 'supply', targetzone = 'Wadi al Jandali', condition = function() return zones.melez.wasBlue end, urgent = zones.wadialjandali.side == 0}),
    GroupCommander:new({name = 'Kibrit-Air-Base-support-Melez', mission = 'supply', targetzone = 'Melez', condition = function() return zones.ramonairbase.wasBlue end}),
	GroupCommander:new({name = 'Kibrit-Air-Base-support-sam-Charlie', mission = 'supply', targetzone = 'SAM-Charlie'})

})
zones.alismailiyah:addGroups({
    GroupCommander:new({name = 'ismailiyah-Patrol-Melez', mission = 'patrol', MissionType='CAP', targetzone = 'Melez', spawnDelayFactor = 1.5}),
	GroupCommander:new({name = 'ismailiyah-support-assalihiyah', mission = 'supply', targetzone = 'As Salihiyah', condition = function() return zones.ramonairbase.wasBlue end, urgent = zones.assalihiyah.side == 0}),
	GroupCommander:new({name = 'ismailiyah-Attack-Al-Salihiyah', mission = 'attack', targetzone = 'As Salihiyah', type = 'surface'})

})
zones.assalihiyah:addGroups({
	GroupCommander:new({name = 'AzZaqaziq-Patrol-Red Carrier', mission = 'patrol', targetzone = 'Red Carrier'}),
    GroupCommander:new({name = 'As-Salihiyah-Support-Sam-Foxtrot', mission = 'supply', targetzone = 'SAM-Foxtrot', type = 'surface'}),
    GroupCommander:new({name = 'As-Salihiyah-Supply-Baluza', mission = 'supply', targetzone = 'Baluza', condition = function() return zones.ramonairbase.wasBlue end, urgent = zones.baluza.side == 0}),
	GroupCommander:new({name = 'As-Salihiyah-supply-al-ismailiyah', mission = 'supply', targetzone = 'Al Ismailiyah', condition = function() return zones.ramonairbase.wasBlue end}),
    GroupCommander:new({name = 'As-Salihiyah-Support-Sam-Foxtrot-blue', mission = 'supply', targetzone = 'SAM-Foxtrot', type = 'surface'}),
    GroupCommander:new({name = 'As-Salihiyah-Patrol-Melez', mission = 'patrol', targetzone = 'Melez'}),
    GroupCommander:new({name = 'As-Salihiyah-attack-Melez', mission = 'attack', MissionType='CAP', targetzone = 'Melez'}),
	GroupCommander:new({name = 'As-Salihiyah-Azzaqaziq-blue', mission = 'supply', targetzone = 'AzZaqaziq'}),
	GroupCommander:new({name = 'As-Salihiyah-Attack-Ramon', mission = 'attack', targetzone = 'Ramon Airbase'}),
	GroupCommander:new({name = 'As-Salihiyah-Supply-AzZaqaziq', mission = 'supply', targetzone = 'AzZaqaziq', condition = function() return zones.melez.wasBlue end, urgent = zones.azzaqaziq.side == 0}),
	GroupCommander:new({name = 'As-Salihiyah-Supply-almansurah', mission = 'supply', targetzone = 'Al Mansurah', condition = function() return zones.melez.wasBlue end, urgent = zones.almansurah.side == 0})
})

zones.inshasairbase:addGroups({
    GroupCommander:new({name = 'Inshas-Airbase-patrol-al-ismailiyah', mission = 'patrol', MissionType='CAP', targetzone = 'Al Ismailiyah'}),
    GroupCommander:new({name = 'Inshas-AirBase-Support-Cairo-International', mission = 'supply', targetzone = 'Cairo International Airport'}),
    GroupCommander:new({name = 'Inshas-AirBase-Support-Cairo-West-Blue', mission = 'supply', targetzone = 'Cairo West'}),
    GroupCommander:new({name = 'Inshas-AirBase-Support-Cairo-West', mission = 'supply', targetzone = 'Cairo West', condition = function() return zones.alismailiyah.wasBlue end, urgent = zones.cairowest.side == 0})
})
zones.komawshim:addGroups({
    GroupCommander:new({name = 'Kom-Awshim-Support-Beni-Suef', mission = 'supply', targetzone = 'Beni Suef'}),
    GroupCommander:new({name = 'Kom-Awshim-Support-Cairo West', mission = 'supply', targetzone = 'Cairo West'}),
    GroupCommander:new({name = 'Kom-Awshim-Support-Beni-Suef-Blue', mission = 'supply', targetzone = 'Beni Suef'})
})
zones.birmaairbase:addGroups({
    GroupCommander:new({name = 'Birma-Air-Base-attack-Al Ismailiyah', mission = 'attack', MissionType='CAP', targetzone = 'Al Ismailiyah'}),
	GroupCommander:new({name = 'Birma-Air-Base-Support-jiyanklisairbase', mission = 'supply', targetzone = 'Jiyanklis Air Base', condition = function() return zones.azzaqaziq.wasBlue end, urgent = zones.jiyanklisairbase.side == 0}),
	GroupCommander:new({name = 'Birma-Air-Base-Support-jiyanklisairbase-blue', mission = 'supply', targetzone = 'Jiyanklis Air Base'})

})
zones.gebelelbasur:addGroups({
    GroupCommander:new({name = 'gebelelbasur-support-Birma-Air-Base', mission = 'supply', targetzone = 'Birma Air Base'}),
    GroupCommander:new({name = 'gebelelbasur-support-Birma-Air-Base-blue', mission = 'supply', targetzone = 'Birma Air Base'})
})
zones.jiyanklisairbase:addGroups({
    GroupCommander:new({name = 'Jiyanklis-Air-Base-patrol-SAM-Hotel', mission = 'patrol', MissionType='CAP', targetzone = 'SAM-Hotel'}),
	GroupCommander:new({name = 'Jiyanklis-Air-Base-Support-borg-el-arab', mission = 'supply', targetzone = 'Borg El Arab International Airport', condition = function() return zones.almansurah.wasBlue end, urgent = zones.borgelarab.side == 0}),
	GroupCommander:new({name = 'Jiyanklis-Air-Base-Support-borg-el-arab-blue', mission = 'supply', targetzone = 'Borg El Arab International Airport'})

})
zones.cairowest:addGroups({
    GroupCommander:new({name = 'CairoWest-Support-Melez', mission = 'supply', targetzone = 'Melez'}),
    GroupCommander:new({name = 'CairoWest-Patrol-Wadi', mission = 'patrol', MissionType='CAP', targetzone = 'Wadi al Jandali'}),
    GroupCommander:new({name = 'CairoWest-Patrol-AzZaqaziq', mission = 'patrol', MissionType='CAP', targetzone = 'AzZaqaziq'}),
    GroupCommander:new({name = 'CairoWest-Support-Wadi', mission = 'supply', targetzone = 'Wadi al Jandali'}),
    GroupCommander:new({name = 'CairoWest-Patrol-Cario-West', mission = 'patrol', MissionType='CAP', targetzone = 'Cairo West'})
})

zones.borgelarab:addGroups({
    GroupCommander:new({name = 'borg-el-arab-Support-SAM-India', mission = 'supply', targetzone = 'SAM-India'}),
    GroupCommander:new({name = 'borg-el-arab-patrol-jiyanklis-air-base', mission = 'patrol', MissionType='CAP', targetzone = 'Jiyanklis Air Base'})

})

function SpawnFriendlyAssets()
	if zones.melez.wasBlue and zones.samdelta.wasBlue then
		SpawnGroupIfNotActive('Blue AWACS-Melez')
		SpawnGroupIfNotActive('airforce-tanker-Melez')
		SpawnGroupIfNotActive('navy-tanker-Melez')
		SpawnGroupIfNotActive('navy-tanker-Melez5')

		destroyGroupIfActive('airforce-tanker')
		destroyGroupIfActive('navy-tanker')
	end
		if zones.melez.wasBlue and zones.samdelta.side == 1 then
		trigger.action.outTextForCoalition(2,'Texaco and Arco together with Awacs will start from Melez once SAM-Delta neutralized.',30)
		if not missionCompleted and trigger.misc.getUserFlag(180) == 0 then
            trigger.action.outSoundForCoalition(2, "admin.wav")
        end
	end
	if zones.ramonairbase.wasBlue and zones.sambravo.wasBlue and not zones.melez.wasBlue then
		SpawnGroupIfNotActive('airforce-tanker')
		SpawnGroupIfNotActive('navy-tanker')
	end
	if zones.redcarrier.wasBlue then
		trigger.action.setMarkupTypeLine(zones.bluecarrier.index, 0)
		activateGroupIfNotActive('CVN-73')
		activateGroupIfNotActive('LHA Tarawa')
		destroyGroupIfActive('CVN-72')
	end
end
mist.scheduleFunction(SpawnFriendlyAssets, {}, timer.getTime() + 8)


if zones.redcarrier.wasBlue then
zones.bluecarrier.isHeloSpawn = false
else
zones.bluecarrier.isHeloSpawn = true
end
zones.bengurion.isHeloSpawn = true
zones.redcarrier.isHeloSpawn = true
zones.hatzor.isHeloSpawn = true
zones.kedemhatzerim.isHeloSpawn = true
zones.nevatim.isHeloSpawn = true
zones.ramonairbase.isHeloSpawn = true
zones.elgora.isHeloSpawn = true
zones.elarish.isHeloSpawn = true
zones.ovda.isHeloSpawn = true
zones.birhasanah.isHeloSpawn = true
zones.melez.isHeloSpawn = true
zones.baluza.isHeloSpawn = true
zones.assalihiyah.isHeloSpawn = true
zones.alismailiyah.isHeloSpawn = true

zones.kibritairbase.isHeloSpawn = true
zones.almansurah.isHeloSpawn = true
zones.azzaqaziq.isHeloSpawn = true
zones.inshasairbase.isHeloSpawn = true
zones.cairointernationalairport.isHeloSpawn = true
zones.wadialjandali.isHeloSpawn = true
zones.cairowest.isHeloSpawn = true
zones.benisuef.isHeloSpawn = true
zones.gebelelbasur.isHeloSpawn = true
zones.komawshim.isHeloSpawn = true
zones.birmaairbase.isHeloSpawn = true
zones.farpalpha.isHeloSpawn = true
zones.farpbravo.isHeloSpawn = true
zones.farpcharlie.isHeloSpawn = true
zones.jiyanklisairbase.isHeloSpawn = true
zones.borgelarab.isHeloSpawn = true

zones.hatzor.airbaseName = "Hatzor"
zones.kedemhatzerim.airbaseName = "Hatzerim"
zones.kedemhatzerim.airbaseName = "Kedem"
zones.nevatim.airbaseName = "Nevatim"
zones.ramonairbase.airbaseName = "Ramon Airbase"
zones.elgora.airbaseName = "El Gora"
zones.elarish.airbaseName = "El Arish"
zones.ovda.airbaseName = "Ovda"
zones.birhasanah.airbaseName = "Bir Hasanah"
zones.melez.airbaseName = "Melez"
zones.baluza.airbaseName = "Baluza"
zones.assalihiyah.airbaseName = "As Salihiyah"
zones.alismailiyah.airbaseName = "Al Ismailiyah"
zones.kibritairbase.airbaseName = "Kibrit Air Base"
zones.almansurah.airbaseName = "Al Mansurah"
zones.azzaqaziq.airbaseName = "AzZaqaziq"
zones.inshasairbase.airbaseName = "Inshas Airbase"
zones.cairointernationalairport.airbaseName = "Cairo International Airport"
zones.wadialjandali.airbaseName = "Wadi al Jandali"
zones.cairowest.airbaseName = "Cairo West"
zones.benisuef.airbaseName = "Beni Suef"
zones.gebelelbasur.airbaseName = "Gebel El Basur Air Base"
zones.komawshim.airbaseName = "Kom Awshim"
zones.birmaairbase.airbaseName = "Birma Air Base"
zones.jiyanklisairbase.airbaseName = "Jiyanklis Air Base"
zones.borgelarab.airbaseName = "Borg El Arab International Airport"
zones.farpalpha.airbaseName = "FARP Alpha"
zones.farpbravo.airbaseName = "FARP Bravo"
zones.farpcharlie.airbaseName = "FARP Charlie"

function checkAndDisableFriendlyZones()
     if zones.ramonairbase.wasBlue and zones.kedemhatzerim.wasBlue and zones.nevatim.wasBlue then
        zones.hatzor:disableFriendlyZone()
        zones.sdedov:disableFriendlyZone()
        zones.bengurion:disableFriendlyZone()
        zones.palmahim:disableFriendlyZone()
        zones.telnof:disableFriendlyZone()
        zones.kedemhatzerim:disableFriendlyZone()
        zones.nevatim:disableFriendlyZone()
        zones.samalpha:disableFriendlyZone()
    end
	if zones.ramonairbase.wasBlue and not zones.assalihiyah.firstCaptureByRed then 
		zones.assalihiyah:MakeZoneRedAndUpgrade()
		zones.farpbravo:MakeZoneRedAndUpgrade()
		zones.birhasanah:MakeZoneRedAndUpgrade()
		zones.alismailiyah:MakeZoneRedAndUpgrade()
	end	
	if zones.wadialjandali.wasBlue and not zones.cairowest.firstCaptureByRed then 
		zones.cairowest:MakeZoneRedAndUpgrade()
	end
	if zones.almansurah.wasBlue and not zones.birmaairbase.firstCaptureByRed then 
		zones.birmaairbase:MakeZoneRedAndUpgrade()
	end
	if zones.melez.wasBlue and not zones.samhotel.firstCaptureByRed then 
		zones.samhotel:MakeZoneRedAndUpgrade()
	end
	if zones.melez.wasBlue and zones.ramonairbase.wasBlue and zones.ramonairbase.active then
		zones.ramonairbase:disableFriendlyZone()
    end
	if zones.farpbravo.wasBlue and zones.ramonairbase.wasBlue and zones.farpalpha.wasBlue and
	zones.farpalpha.active and zones.ovda.wasBlue then
		zones.farpalpha:disableFriendlyZone()
	end
	if zones.melez.wasBlue and zones.sambravo.wasBlue and zones.sambravo.active then
		zones.sambravo:disableFriendlyZone()
    end
	if zones.melez.wasBlue and zones.elarish.wasBlue and zones.elarish.active then
		zones.elarish:disableFriendlyZone()
    end
	if zones.melez.wasBlue and zones.elgora.wasBlue and zones.elgora.active then
		zones.elgora:disableFriendlyZone()
    end
	if zones.melez.wasBlue and zones.ovda.wasBlue and zones.ovda.active then
		zones.ovda:disableFriendlyZone()
    end
	if zones.ovda.wasBlue and zones.farpbravo.wasBlue and zones.farpbravo.active and 
		zones.farpbravo.wasBlue and zones.farpbravo.active then
		zones.farpbravo:disableFriendlyZone()
    end
	 if zones.wadialjandali.wasBlue and zones.melez.wasBlue then
        zones.melez:disableFriendlyZone()
		zones.samdelta:disableFriendlyZone()
    end
	 if zones.wadialjandali.wasBlue and zones.kibritairbase.wasBlue then
		zones.kibritairbase:disableFriendlyZone()
    end
	if zones.melez.wasBlue and zones.farpcharlie.wasBlue and zones.baluza.wasBlue and
	zones.farpcharlie.active then
		zones.farpcharlie:disableFriendlyZone()
	end
	 if zones.wadialjandali.wasBlue and zones.alismailiyah.wasBlue then
		zones.alismailiyah:disableFriendlyZone()
    end
	 if zones.almansurah.wasBlue and zones.assalihiyah.wasBlue and not zones.samindia.firstCaptureByRed then
		zones.assalihiyah:disableFriendlyZone()
		zones.samindia:MakeZoneRedAndUpgrade()
    end
	 if zones.assalihiyah.wasBlue and zones.baluza.wasBlue and zones.baluza.active then
		zones.baluza:disableFriendlyZone()
	end

	 if zones.assalihiyah.wasBlue and zones.redcarrier.wasBlue and zones.samecho.wasBlue then
		zones.samecho:disableFriendlyZone()
    end
	 if zones.wadialjandali.wasBlue and zones.samcharlie.wasBlue and zones.assalihiyah.wasBlue then
		zones.samcharlie:disableFriendlyZone()
    end
	 if zones.almansurah.wasBlue and zones.jiyanklisairbase.wasBlue then
		zones.almansurah:disableFriendlyZone()
    end
	 if zones.azzaqaziq.wasBlue and zones.jiyanklisairbase.wasBlue and zones.wadialjandali.wasBlue then
		zones.azzaqaziq:disableFriendlyZone()
	end
	
end

mist.scheduleFunction(checkAndDisableFriendlyZones, {}, timer.getTime() + 5)

missions = {

}

for i,v in pairs(zones) do
	bc:addZone(v)
end

bc:addConnection("Blue Carrier","Sde Dov")
bc:addConnection("Sde Dov","Ben-Gurion")
bc:addConnection("Ben-Gurion","Palmahim")
bc:addConnection("Palmahim","Tel Nof")
bc:addConnection("Tel Nof","Hatzor")
bc:addConnection("Hatzor","Kedem-Hatzerim")
bc:addConnection("Hatzor","SAM-Alpha")
bc:addConnection("Kedem-Hatzerim","Nevatim")
bc:addConnection("Kedem-Hatzerim","Ramon Airbase")
bc:addConnection("Nevatim","Ramon Airbase")
bc:addConnection("Ramon Airbase","FARP-Alpha")
bc:addConnection("Ramon Airbase","SAM-Bravo")
bc:addConnection("Ramon Airbase","MiningFacility")
bc:addConnection("FARP-Alpha","Ovda")
bc:addConnection("Ovda","FARP-Bravo")
bc:addConnection("Ovda","SecretTechFacility")
bc:addConnection("Ovda","InsurgentCamp")
bc:addConnection("Ovda","FuelDepo")
bc:addConnection("FARP-Bravo","El Gora")
bc:addConnection("El Gora","El Arish")
bc:addConnection("El Arish","FARP-Charlie")
bc:addConnection("FARP-Charlie","Baluza")
bc:addConnection("FARP-Charlie","Melez")
bc:addConnection("Melez","SAM-Delta")
bc:addConnection("Melez","Bir Hasanah")
bc:addConnection("Bir Hasanah","SAM-Charlie")
bc:addConnection("Bir Hasanah","ChemSite")
bc:addConnection("Baluza","Port Said")
bc:addConnection("Baluza","SAM-Echo")
bc:addConnection("Baluza","Red Carrier")
bc:addConnection("Red Carrier","As Salihiyah")
bc:addConnection("As Salihiyah","Al Ismailiyah")
bc:addConnection("As Salihiyah","SAM-Foxtrot")
bc:addConnection("Al Ismailiyah", "Kibrit Air Base")
bc:addConnection("Kibrit Air Base", "Wadi al Jandali")
bc:addConnection("Wadi al Jandali", "Cairo International Airport")
bc:addConnection("Wadi al Jandali","SAM-Golf")
bc:addConnection("Cairo International Airport", "Inshas Airbase")
bc:addConnection("Inshas Airbase", "AzZaqaziq")
bc:addConnection("AzZaqaziq","Al Mansurah")
bc:addConnection("Al Mansurah","ArtilleryFactory")
bc:addConnection("Al Mansurah","Borj Oil production Site")
bc:addConnection("Al Mansurah","SAM-Hotel")
bc:addConnection("SAM-Hotel","Birma Air Base")
bc:addConnection("Birma Air Base","Jiyanklis Air Base")
bc:addConnection("Jiyanklis Air Base","Borg El Arab International Airport")
bc:addConnection("Borg El Arab International Airport","SAM-India")
bc:addConnection("Borg El Arab International Airport", "Gebel El Basur Air Base")
bc:addConnection("Gebel El Basur Air Base", "Cairo West")
bc:addConnection("Cairo West","MissileFactory")
bc:addConnection("Cairo West", "Kom Awshim")
bc:addConnection("Kom Awshim", "Beni Suef")
bc:addConnection("Beni Suef","SAM-Juliett")
bc:addConnection("Beni Suef","TankFactory")
bc:addConnection("Beni Suef","AmmonitionDepo")

--[[
zones.tankfactory:addCriticalObject('TankFactory1')
zones.tankfactory:addCriticalObject('TankFactory2')
zones.tankfactory:addCriticalObject('TankFactory3')
zones.tankfactory:addCriticalObject('TankFactory4')

zones.fueldepo:addCriticalObject('Fueldepo1')
zones.fueldepo:addCriticalObject('Fueldepo2')
zones.fueldepo:addCriticalObject('Fueldepo3')
zones.fueldepo:addCriticalObject('Fueldepo4')
zones.fueldepo:addCriticalObject('Fueldepo5')
zones.fueldepo:addCriticalObject('Fueldepo6')


zones.chemsite:addCriticalObject('chemsite1')
zones.chemsite:addCriticalObject('chemsite2')
zones.chemsite:addCriticalObject('chemsite3')
zones.chemsite:addCriticalObject('chemsite4')
zones.chemsite:addCriticalObject('chemsite5')
zones.chemsite:addCriticalObject('chemsite6')
zones.chemsite:addCriticalObject('chemsite7')
zones.chemsite:addCriticalObject('chemsite8')

zones.missilefactory:addCriticalObject('missilefactory1')
zones.missilefactory:addCriticalObject('missilefactory2')

zones.secrettechfacility:addCriticalObject('SecretTechFacility1')
zones.secrettechfacility:addCriticalObject('SecretTechFacility2')
zones.secrettechfacility:addCriticalObject('SecretTechFacility3')
zones.secrettechfacility:addCriticalObject('SecretTechFacility4')
zones.secrettechfacility:addCriticalObject('SecretTechFacility5')


zones.ammonitiondepo:addCriticalObject('Ammodepo1')
zones.ammonitiondepo:addCriticalObject('Ammodepo2')
zones.ammonitiondepo:addCriticalObject('Ammodepo3')
zones.ammonitiondepo:addCriticalObject('Ammodepo4')

--]]


zones.tankfactory:registerTrigger('lost', function(event, sender) 
	sender:disableZone()
end, 'disabletankfactory2')

zones.fueldepo:registerTrigger('lost', function(event, sender) 
	sender:disableZone()
end, 'disablefueldepo1')

zones.portsaid:registerTrigger('lost', function(event, sender) 
	sender:disableZone()
end, 'disableportsaid')


zones.secrettechfacility:registerTrigger('lost', function(event, sender) 
	sender:disableZone()
end, 'disablesecrettechfacility1')

zones.artilleryfactory:registerTrigger('lost', function(event, sender) 
	sender:disableZone()
	bc:addFunds(2,500)
	trigger.action.outTextForCoalition(2,'Artillery Factory disabled\n+500 credits',20)
end, 'disableartilleryfactory')

zones.miningfacility:registerTrigger('lost', function(event, sender) 
	sender:disableZone()
	bc:addFunds(2,500)
	trigger.action.outTextForCoalition(2,'Mining Facility cleared\n+500 credits',20)
end, 'disableminingfacility')


zones.ammonitiondepo:registerTrigger('lost', function(event, sender) 
	sender:disableZone()
end, 'disableammonitiondepo2')

zones.insurgentcamp:registerTrigger('lost', function(event, sender) 
	sender:disableZone()
	bc:addFunds(2,500)
	trigger.action.outTextForCoalition(2,'Insurgent Camp destroyed, Good job\n+500 credits',20)
end, 'disableinsurgentcamp')


zones.chemsite:registerTrigger('lost', function(event, sender) 
	sender:disableZone()
end, 'disablechemsite1')

zones.missilefactory:registerTrigger('lost', function(event, sender) 
	sender:disableZone()
	bc:addFunds(2,500)
	trigger.action.outTextForCoalition(2,'Missile Factroy destroyed, Good job\n+500 credits',20)
end, 'disablemissilefactory')

------------------------------------------ SAM DISABLE --------------------------------------------

zones.samhotel:registerTrigger('lost', function(event, sender) 
	sender:disableZone()
	bc:addFunds(2,500)
	trigger.action.outTextForCoalition(2,'SAM Hotel is now destroyed, Good job\n+500 credits',20)
end, 'disablesamhotel')


zones.samindia:registerTrigger('lost', function(event, sender) 
	sender:disableZone()
	bc:addFunds(2,500)
	trigger.action.outTextForCoalition(2,'SAM India is now destroyed, Good job\n+500 credits',20)
end, 'disablesamindia')

------------------------------------------ SAM DISABLE --------------------------------------------

local missionCompleted = false
local checkMissionComplete = function(event, sender)
	local done = true
	for i, v in ipairs(bc:getZones()) do
		if not v.zone:lower():find("hidden") and v.side == 1 then
			done = false
			break
		end
	end

	if done then
		missionCompleted = true
		trigger.action.setUserFlag(180, true)
		trigger.action.outText("Enemy has been defeated.\n\nMission Complete.\n\nYou can restart the mission from the radio menu.", 120)

		timer.scheduleFunction(function()
			trigger.action.outSoundForCoalition(2, "BH.ogg")
		end, {}, timer.getTime() + 5)

			local subMenu = missionCommands.addSubMenuForCoalition(2, "Restart and Reset?", nil)
			missionCommands.addCommandForCoalition(2, "Yes", subMenu, function()
				if bc and bc.saveFile then
					Utils.saveTable(bc.saveFile, 'zonePersistance', {})
				end
				trigger.action.outText("Restarting now..", 120)
				timer.scheduleFunction(function()
					trigger.action.setUserFlag(181, true)
				end, {}, timer.getTime() + 5)
			end)
			missionCommands.addCommandForCoalition(2, "No", subMenu, function()
		end)
	end
end

for i,v in ipairs(bc:getZones()) do
	v:registerTrigger('lost', checkMissionComplete, 'missioncompleted')
end

mist.scheduleFunction(function()
	checkMissionComplete(nil, nil)
	bc:roamGroupsToLocalSubZone({
		"Ground Armour 2 #",
		"Ground Armour 3 #",
		"Ground Armour #",
		"Red SAM AAA 2 #",
		"Red SAM SHORAD SA-15 2 #",
		"Red SAM SHORAD SA-8 2 #",
		"Red SAM SHORAD SA-19 2 #",
		"Neustrashimy #",
		"Molniya #",
		"Rezky #"
	}, 50)
end, {}, timer.getTime() + 30)

local upgradeMenu = nil
bc:registerShopItem('supplies', 'Resupply friendly Zone', 149, function(sender)
    if upgradeMenu then
        return 'Choose zone from F10 menu'
    end
    local upgradeZone = function(target)
        if upgradeMenu then
            local zn = bc:getZoneByName(target)
            if zn and zn.side == 2 then
                zn:upgrade()
            else
                return 'Zone not friendly'
            end           
            upgradeMenu = nil
        end
    end
    upgradeMenu = bc:showTargetZoneMenu(2, 'Select Zone to resupply', upgradeZone, 2, true)
		timer.scheduleFunction(function()
			trigger.action.outTextForCoalition(2, 'Supplies prepared. Choose zone from F10 menu', 15)
		end, {}, timer.getTime() + 3)
    
end,
function(sender, params)
    if params.zone and params.zone.side == 2 then
        params.zone:upgrade()
    else
        return 'Can only target friendly zone'
    end
end)

local fullyUpgradeMenu = nil
bc:registerShopItem('supplies2', 'Fully Upgrade Friendly Zone', 1000, function(sender)
    if fullyUpgradeMenu then
        return 'Choose zone from F10 menu to fully upgrade'
    end
    local fullyUpgradeZone = function(target)
        if fullyUpgradeMenu then
            local zn = bc:getZoneByName(target)
            if zn and zn.side == 2 then
                local function calculateRepairsNeeded()
                    local repairsNeeded = 0
                    for _, v in pairs(zn.built) do
                        local gr = Group.getByName(v)
                        if gr then
                            local units = gr:getUnits()
                            local allUnitsRepaired = true

                            for _, unit in ipairs(units) do
                                if unit and unit:isExist() then
                                    local unitLife = unit:getLife()
                                    local unitLifeMax = unit:getLife0()

                                    if unitLife < unitLifeMax then
                                        allUnitsRepaired = false
                                        break
                                    end
                                end
                            end

                            if not allUnitsRepaired or gr:getSize() < gr:getInitialSize() then
                                repairsNeeded = repairsNeeded + 1
                            end
                        end
                    end
                    return repairsNeeded
                end

                local totalRepairs = calculateRepairsNeeded()
                local upgrades = zn.upgrades.blue
                local currentUpgrades = Utils.getTableSize(zn.built)
                local totalUpgrades = #upgrades
                local upgradesToMake = totalUpgrades - currentUpgrades

                local totalToUpgrade = totalRepairs + upgradesToMake
                if totalToUpgrade > 0 then
                    for i = 1, totalToUpgrade do
                        mist.scheduleFunction(function()
                            zn:upgrade()
                        end, {}, timer.getTime() + i)
                    end

                    mist.scheduleFunction(function()
                        trigger.action.outTextForCoalition(2, target .. ' is now fully upgraded!', 15)
                    end, {}, timer.getTime() + totalToUpgrade + 1)
                else
                    trigger.action.outTextForCoalition(2, target .. ' is already fully upgraded', 15)
                end
            else
                return 'Zone not friendly'
            end
            fullyUpgradeMenu = nil
        end
    end

    fullyUpgradeMenu = bc:showTargetZoneMenu(2, 'Select Zone to Fully Upgrade', fullyUpgradeZone, 2, true)
		timer.scheduleFunction(function()
			trigger.action.outTextForCoalition(2, 'Preparing to full upgrade and repair. Choose zone from F10 menu', 15)
		end, {}, timer.getTime() + 3)
    
end)

Group.getByName('f16cap1'):destroy()
Group.getByName('f16cap2'):destroy()
Group.getByName('f16cap3'):destroy()
Group.getByName('f16cap4'):destroy()
Group.getByName('f16cap5'):destroy()

bc:registerShopItem('cap', 'CAP ', 300, function(sender)
    local grname = 'f16cap1'
        if zones.ramonairbase.wasBlue and zones.kedemhatzerim.wasBlue and zones.melez.side == 1 then
        grname = 'f16cap2'
		elseif zones.melez.wasBlue and zones.ramonairbase.wasBlue and zones.assalihiyah.side == 1 then
        grname = 'f16cap3'
		elseif zones.assalihiyah.wasBlue and zones.kibritairbase.wasBlue and zones.almansurah.side == 1 then
        grname = 'f16cap4'
		elseif zones.birmaairbase.wasBlue and zones.almansurah.wasBlue and zones.azzaqaziq.wasBlue then
        grname = 'f16cap5'
    end
        local gr = Group.getByName(grname)
        if Utils.isGroupActive(gr) then
            return 'CAP mission still in progress'
        end

        mist.respawnGroup(grname, true)
    end, 
    function(sender, params)
    local grname = 'f16cap1'
        if zones.ramonairbase.wasBlue and zones.kedemhatzerim.wasBlue and zones.melez.side == 1 then
        grname = 'f16cap2'
		elseif zones.melez.wasBlue and zones.ramonairbase.wasBlue and zones.assalihiyah.side == 1 then
        grname = 'f16cap3'
		elseif zones.assalihiyah.wasBlue and zones.kibritairbase.wasBlue and zones.almansurah.side == 1 then
        grname = 'f16cap4'
		elseif zones.birmaairbase.wasBlue and zones.almansurah.wasBlue and zones.azzaqaziq.wasBlue then
        grname = 'f16cap5'
    end

        local gr = Group.getByName(grname)
        if Utils.isGroupActive(gr) then
            return 'CAP mission still in progress'
        end

        mist.respawnGroup(grname, true)
end)

tanksMenu = nil
bc:registerShopItem('armor', 'Deploy armor (for combined arms) ', 300, function(sender)
	
	if tanksMenu then
		return 'Choose deploy zone from F10 menu'
	end
	
	local deployTanks = function(target)
		if tanksMenu then
		
			local zn = CustomZone:getByName(target)
			zn:spawnGroup('ca-tanks')
			
			tanksMenu = nil
			trigger.action.outTextForCoalition(2, 'Friendly armor deployed at '..target, 15)
		end
	end
	
	tanksMenu = bc:showTargetZoneMenu(2, 'Deploy armor (Choose friendly zone) ', deployTanks, 2)
		timer.scheduleFunction(function()
			trigger.action.outTextForCoalition(2, 'Choose deploy zone from F10 menu', 15)
		end, {}, timer.getTime() + 3)
end,
function(sender, params)
	if params.zone and params.zone.side == 2 then
		
		local zn = CustomZone:getByName(params.zone.zone)
		zn:spawnGroup('ca-tanks')
		trigger.action.outTextForCoalition(2, 'Friendly armor deployed at '..params.zone.zone, 15)
	else
		return 'Can only deploy at friendly zone'
	end
end)

artyMenu = nil
bc:registerShopItem('artillery', 'Deploy artillery (for combined arms) ', 200, function(sender)
	
	if artyMenu then
		return 'Choose deploy zone from F10 menu'
	end
	
	local deployArty = function(target)
		if artyMenu then
		
			local zn = CustomZone:getByName(target)
			zn:spawnGroup('ca-arty')
			
			artyMenu = nil
			trigger.action.outTextForCoalition(2, 'Friendly artillery deployed at '..target, 15)
		end
	end
	
	artyMenu = bc:showTargetZoneMenu(2, 'Deploy artillery (Choose friendly zone) ', deployArty, 2)
		timer.scheduleFunction(function()
			trigger.action.outTextForCoalition(2, 'Choose deploy zone from F10 menu', 15)
		end, {}, timer.getTime() + 3)
end,
function(sender, params)
	if params.zone and params.zone.side == 2 then
		
		local zn = CustomZone:getByName(params.zone.zone)
		zn:spawnGroup('ca-arty')
		trigger.action.outTextForCoalition(2, 'Friendly artillery deployed at '..params.zone.zone, 15)
	else
		return 'Can only deploy at friendly zone'
	end
end)

reconMenu = nil
bc:registerShopItem('recon', 'Deploy recon group (for combined arms)', 50, function(sender)
	
	if reconMenu then
		return 'Choose deploy zone from F10 menu'
	end
	
	local deployRecon = function(target)
		if reconMenu then
		
			local zn = CustomZone:getByName(target)
			zn:spawnGroup('ca-recon')
			
			reconMenu = nil
			trigger.action.outTextForCoalition(2, 'Friendly recon group deployed at '..target, 15)
		end
	end
	
	reconMenu = bc:showTargetZoneMenu(2, 'Deploy recon group (Choose friendly zone)', deployRecon, 2)
		timer.scheduleFunction(function()
			trigger.action.outTextForCoalition(2, 'Choose deploy zone from F10 menu', 15)
		end, {}, timer.getTime() + 3)
end,
function(sender, params)
	if params.zone and params.zone.side == 2 then
		
		local zn = CustomZone:getByName(params.zone.zone)
		zn:spawnGroup('ca-recon')
		trigger.action.outTextForCoalition(2, 'Friendly recon group deployed at '..params.zone.zone, 15)
	else
		return 'Can only deploy at friendly zone'
	end
end)

airdefMenu = nil
bc:registerShopItem('airdef', 'Deploy air defence (for combined arms)', 150, function(sender)
	
	if airdefMenu then
		return 'Choose deploy zone from F10 menu'
	end
	
	local deployAirDef = function(target)
		if airdefMenu then
		
			local zn = CustomZone:getByName(target)
			zn:spawnGroup('ca-airdef')
			
			airdefMenu = nil
			trigger.action.outTextForCoalition(2, 'Friendly air defence deployed at '..target, 15)
		end
	end
	
	airdefMenu = bc:showTargetZoneMenu(2, 'Deploy air defence (Choose friendly zone)', deployAirDef, 2)
		timer.scheduleFunction(function()
			trigger.action.outTextForCoalition(2, 'Choose deploy zone from F10 menu', 15)
		end, {}, timer.getTime() + 3)
	
end,
function(sender, params)
	if params.zone and params.zone.side == 2 then
		
		local zn = CustomZone:getByName(params.zone.zone)
		zn:spawnGroup('ca-airdef')
		trigger.action.outTextForCoalition(2, 'Friendly air defence deployed at '..params.zone.zone, 15)
	else
		return 'Can only deploy at friendly zone'
	end
end)


Group.getByName('jtacDrone'):destroy()
local jtacTargetMenu = nil
drone = JTAC:new({name = 'jtacDrone'})
bc:registerShopItem('jtac', 'MQ-9 Reaper JTAC mission ', 300, function(sender)
	
	if jtacTargetMenu then
		return 'Choose target zone from F10 menu'
	end
	
	local spawnAndOrbit = function(target)
		if jtacTargetMenu then
			local zn = bc:getZoneByName(target)
			drone:deployAtZone(zn)
			drone:showMenu()
			trigger.action.outTextForCoalition(2, 'Reaper drone deployed over '..target, 15)
			jtacTargetMenu = nil
		end
	end
	
	jtacTargetMenu = bc:showTargetZoneMenu(2, 'Deploy JTAC ', spawnAndOrbit, 1)

		timer.scheduleFunction(function()
			trigger.action.outTextForCoalition(2, 'Choose which zone to deploy JTAC at from F10 menu', 15)
		end, {}, timer.getTime() + 3)
end,
function(sender, params)
	if params.zone and params.zone.side == 1 then
		drone:deployAtZone(params.zone)
		drone:showMenu()
		trigger.action.outTextForCoalition(2, 'Reaper drone deployed over '..params.zone.zone, 15)
	else
		return 'Can only target enemy zone'
	end
end)

local smoketargets = function(tz)
	local units = {}
	for i,v in pairs(tz.built) do
		local g = Group.getByName(v)
		for i2,v2 in ipairs(g:getUnits()) do
			table.insert(units, v2)
		end
	end
	
	local tgts = {}
	for i=1,3,1 do
		if #units > 0 then
			local selected = math.random(1,#units)
			table.insert(tgts, units[selected])
			table.remove(units, selected)
		end
	end
	
	for i,v in ipairs(tgts) do
		local pos = v:getPosition().p
		trigger.action.smoke(pos, 1)
	end
end

local smokeTargetMenu = nil
bc:registerShopItem('smoke', 'Smoke markers ', 20, function(sender)
	if smokeTargetMenu then
		return 'Choose target zone from F10 menu'
	end
	
	local launchAttack = function(target)
		if smokeTargetMenu then
			local tz = bc:getZoneByName(target)
			smoketargets(tz)
			smokeTargetMenu = nil
			trigger.action.outTextForCoalition(2, 'Targets marked with RED smoke at '..target, 15)
		end
	end
	
	smokeTargetMenu = bc:showTargetZoneMenu(2, 'Smoke marker target', launchAttack, 1)
	timer.scheduleFunction(function()
		ttrigger.action.outTextForCoalition(2, 'Choose target zone from F10 menu ', 15)
	end, {}, timer.getTime() + 3)
	
end,
function(sender, params)
	if params.zone and params.zone.side == 1 then
		smoketargets(params.zone)
		trigger.action.outTextForCoalition(2, 'Targets marked with RED smoke at '..params.zone.zone, 15)
	else
		return 'Can only target enemy zone'
	end
end)

------------------------------------ START own 9 line jtac AM START ----------------------------------
local jtacZones = {}
Group.getByName('JTAC9lineam'):destroy()
local jtacTargetMenu2 = nil
local droneAM = JTAC9line:new({name = 'JTAC9lineam'})
bc:registerShopItem('9lineam', 'Jtac 9line AM', 0, function(sender)
    if jtacTargetMenu2 then
        return 'Choose target zone from F10 menu'
    end
    
    local spawnAndOrbit2 = function(target)
        if jtacTargetMenu2 then
            local zn = bc:getZoneByName(target)
            droneAM:deployAtZone(zn)
			
			jtacZones[target] = {drone = 'JTAC9lineam'}
			
		trigger.action.outTextForCoalition(2, 'Reaper drone deployed over ' .. target .. '. Contact Springfield on 241.00 AM ', 30)
        jtacTargetMenu2 = nil
		end
    end
    
    jtacTargetMenu2 = bc:showTargetZoneMenu(2, 'Deploy JTAC to Zone', spawnAndOrbit2, 1)
		timer.scheduleFunction(function()
			trigger.action.outTextForCoalition(2, 'Choose which zone to deploy JTAC at from F10 menu', 15)
		end, {}, timer.getTime() + 3)
end,
function(sender, params)
    if params.zone and params.zone.side == 1 then
        droneAM:deployAtZone(params.zone)
        trigger.action.outTextForCoalition(2, 'Reaper drone deployed over ' .. params.zone.zone .. '. Contact Springfield on 241.00 AM ', 30)
    else
        return 'Can only target enemy zone'
    end
end)

  ------------------------------ END 9 line jtac AM END ----------------------------------
  ----------------------------- START 9 line jtac fm START ---------------------------

Group.getByName('JTAC9linefm'):destroy()
local jtacTargetMenu3 = nil
local droneFM = JTAC9linefmr:new({name = 'JTAC9linefm'})
bc:registerShopItem('9linefm', 'Jtac 9line FM', 0, function(sender)
    if jtacTargetMenu3 then
        return 'Choose target zone from F10 menu'
    end
    
    local spawnAndOrbit3 = function(target)
        if jtacTargetMenu3 then
            local zn = bc:getZoneByName(target)
            droneFM:deployAtZone(zn)
			
			jtacZones[target] = {drone = 'JTAC9linefm'}
			
		trigger.action.outTextForCoalition(2, 'Reaper drone deployed over ' .. target .. '. Contact Uzi on 31.00 FM ', 30)            
            jtacTargetMenu3 = nil
        end
    end
    
    jtacTargetMenu3 = bc:showTargetZoneMenu(2, 'Deploy JTAC to Zone', spawnAndOrbit3, 1)
		timer.scheduleFunction(function()
			trigger.action.outTextForCoalition(2, 'Choose which zone to deploy JTAC at from F10 menu', 15)
		end, {}, timer.getTime() + 3)
end,
function(sender, params)
    if params.zone and params.zone.side == 1 then
        droneFM:deployAtZone(params.zone)
        trigger.action.outTextForCoalition(2, 'Reaper drone deployed over ' .. params.zone.zone .. '. Contact Uzi on 31.00 FM ', 30)
    else
        return 'Can only target enemy zone'
    end
end)

function CheckJtacStatus()
	 if jtacZones == nil then
			return false
		end

    local jtacFound = false
    
    for zoneName, jtacInfo in pairs(jtacZones) do
        local jtacGroup = Group.getByName(jtacInfo.drone)
        if jtacGroup and Utils.isGroupActive(jtacGroup) then
            local zone = bc:getZoneByName(zoneName)
            if zone and zone.side == 0 then
                jtacGroup:destroy()
                jtacZones[zoneName] = nil
                jtacFound = true
            end
        else
            jtacZones[zoneName] = nil
        end
    end

    return jtacFound
end

  -------------------------- END 9 line jtac FM END ----------------------------------



local casTargetMenu = nil
Group.getByName('cas1'):destroy()
Group.getByName('cas2'):destroy()
Group.getByName('cas3'):destroy()
Group.getByName('cas4'):destroy()
Group.getByName('cas5'):destroy()
bc:registerShopItem('cas', 'F-16C Ground Attack ', 400, function(sender)
    local grname = 'cas1'
        if zones.ramonairbase.wasBlue and zones.kedemhatzerim.wasBlue and zones.melez.side == 1 then
        grname = 'cas2'
		elseif zones.melez.wasBlue and zones.ramonairbase.wasBlue and zones.assalihiyah.side == 1 then
        grname = 'cas3'
		elseif zones.assalihiyah.wasBlue and zones.kibritairbase.wasBlue and zones.almansurah.side == 1 then
        grname = 'cas4'
		elseif zones.birmaairbase.wasBlue and zones.almansurah.wasBlue and zones.azzaqaziq.wasBlue then
        grname = 'cas5'
    end

    local gr = Group.getByName(grname)
    if Utils.isGroupActive(gr) then
        return 'Ground attack mission still in progress'
    end

    mist.respawnGroup(grname, true)

    if casTargetMenu then
        return 'Choose target zone from F10 menu'
    end

    local launchAttack = function(target)
        if casTargetMenu then
            if Group.getByName(grname) then
                local err = bc:engageZone(target, grname)
                if err then
                    return err
                end

                trigger.action.outTextForCoalition(2, 'F-16C engaging groups at ' .. target, 15)
            else
                trigger.action.outTextForCoalition(2, 'Group has left the area or has been destroyed', 15)
            end

            casTargetMenu = nil
        end
    end

    casTargetMenu = bc:showTargetZoneMenu(2, 'F-16C Target', launchAttack, 1)
	timer.scheduleFunction(function()
		trigger.action.outTextForCoalition(2, 'F-16C on route. Choose target zone from F10 menu for ' .. grname, 15)
	end, {}, timer.getTime() + 3)
end,
function(sender, params)
    if params.zone and params.zone.side == 1 then
    local grname = 'cas1'
        if zones.ramonairbase.wasBlue and zones.kedemhatzerim.wasBlue and zones.melez.side == 1 then
        grname = 'cas2'
		elseif zones.melez.wasBlue and zones.ramonairbase.wasBlue and zones.assalihiyah.side == 1 then
        grname = 'cas3'
		elseif zones.assalihiyah.wasBlue and zones.kibritairbase.wasBlue and zones.almansurah.side == 1 then
        grname = 'cas4'
		elseif zones.birmaairbase.wasBlue and zones.almansurah.wasBlue and zones.azzaqaziq.wasBlue then
        grname = 'cas5'
    end

        local gr = Group.getByName(grname)
        if gr and gr:getSize() > 0 and gr:getController():hasTask() then
            return 'Ground attack mission still in progress'
        end

        mist.respawnGroup(grname, true)
        mist.scheduleFunction(function(target)
            if Group.getByName(grname) then
                local err = bc:engageZone(target, grname)
                if err then
                    return err
                end

                trigger.action.outTextForCoalition(2, 'F-16C engaging groups at ' .. target, 15)
            end
        end, {params.zone.zone}, timer.getTime() + 2)
    else
        return 'Can only target enemy zone'
    end
end)

local seadTargetMenu = nil
Group.getByName('sead1'):destroy()
Group.getByName('sead2'):destroy()
Group.getByName('sead3'):destroy()
Group.getByName('sead4'):destroy()
Group.getByName('sead5'):destroy()

bc:registerShopItem('sead', 'F/A-18C SEAD mission ', 500, function(sender)
    local grname = 'sead1'
        if zones.ramonairbase.wasBlue and zones.kedemhatzerim.wasBlue and zones.melez.side == 1 then
        grname = 'sead2'
		elseif zones.melez.wasBlue and zones.ramonairbase.wasBlue and zones.assalihiyah.side == 1 then
        grname = 'sead3'
		elseif zones.assalihiyah.wasBlue and zones.kibritairbase.wasBlue and zones.almansurah.side == 1 then
        grname = 'sead4'
		elseif zones.birmaairbase.wasBlue and zones.almansurah.wasBlue and zones.azzaqaziq.wasBlue then
        grname = 'sead5'
    end

    local gr = Group.getByName(grname)
    if Utils.isGroupActive(gr) then
        return 'SEAD mission still in progress'
    end

    mist.respawnGroup(grname, true)

    if seadTargetMenu then
        return 'Choose target zone from F10 menu'
    end

    local launchAttack = function(target)
        if seadTargetMenu then
            if Group.getByName(grname) then
                local err = bc:engageSead(target, grname, AI.Task.WeaponExpend.ALL)
                if err then
                    return err
                end

                trigger.action.outTextForCoalition(2, 'F/A-18C engaging SAMs at ' .. target, 15)
            else
                trigger.action.outTextForCoalition(2, 'Group has left the area or has been destroyed', 15)
            end

            seadTargetMenu = nil
        end
    end

    seadTargetMenu = bc:showTargetZoneMenu(2, 'SEAD Target', launchAttack, 1)

    trigger.action.outTextForCoalition(2, 'F/A-18C on route. Choose target zone from F10 menu for ' .. grname, 15)
end,
	function(sender, params)
    if params.zone and params.zone.side == 1 then
    local grname = 'sead1'
        if zones.ramonairbase.wasBlue and zones.kedemhatzerim.wasBlue and zones.melez.side == 1 then
        grname = 'sead2'
		elseif zones.melez.wasBlue and zones.ramonairbase.wasBlue and zones.assalihiyah.side == 1 then
        grname = 'sead3'
		elseif zones.assalihiyah.wasBlue and zones.kibritairbase.wasBlue and zones.almansurah.side == 1 then
        grname = 'sead4'
		elseif zones.birmaairbase.wasBlue and zones.almansurah.wasBlue and zones.azzaqaziq.wasBlue then
        grname = 'sead5'
    end

        local gr = Group.getByName(grname)
        if gr and gr:getSize() > 0 and gr:getController():hasTask() then
            return 'SEAD mission still in progress'
        end

        mist.respawnGroup(grname, true)
        mist.scheduleFunction(function(target)
            if Group.getByName(grname) then
                local err = bc:engageSead(target, grname)
                if err then
                    return err
                end

                trigger.action.outTextForCoalition(2, 'F/A-18C engaging SAMs at ' .. target, 15)
            end
        end, {params.zone.zone}, timer.getTime() + 2)
    else
        return 'Can only target enemy zone'
    end
end)

-- new menu
local supplyMenu=nil
bc:registerShopItem('capture','Emergency capture neutral zone',500,
function(sender)
	if supplyMenu then
		return 'Choose a zone from F10 menu'
	end
    local cost=500
    trigger.action.outTextForCoalition(2,'Select zone from F10 menu',15)
    supplyMenu=bc:showEmergencyNeutralZoneMenu(2,'Select Zone for Emergency capture',
    function(zonename)
        if not zonename then
            bc:addFunds(2,cost)
            if supplyMenu then missionCommands.removeItemForCoalition(2,supplyMenu) end
            supplyMenu=nil
            trigger.action.outTextForCoalition(2,'No zone name selected, purchase refunded',10)
            return 'No zone name'
        end
        local chosenZone=bc:getZoneByName(zonename)
        if not chosenZone then
            bc:addFunds(2,cost)
            if supplyMenu then missionCommands.removeItemForCoalition(2,supplyMenu) end
            supplyMenu=nil
            trigger.action.outTextForCoalition(2,'Zone not found, purchase refunded',10)
            return 'Zone not found'
        end
        if chosenZone.side~=0 then
            bc:addFunds(2,cost)
            if supplyMenu then missionCommands.removeItemForCoalition(2,supplyMenu) end
            supplyMenu=nil
            trigger.action.outTextForCoalition(2,'Zone is not neutral anymore, purchase refunded',10)
            return 'Zone is no longer neutral!'
        end
        local bestCommander,status=findNearestAvailableSupplyCommander(chosenZone)
        if not bestCommander then
            bc:addFunds(2,cost)
            if supplyMenu then missionCommands.removeItemForCoalition(2,supplyMenu) end
            supplyMenu=nil
            if status=='inprogress' then
                trigger.action.outTextForCoalition(2,'Supply to '..chosenZone.zone..' already in progress, purchase refunded',10)
                return 'Supply mission in progress for this zone'
            else
                trigger.action.outTextForCoalition(2,'No suitable supply group found for '..chosenZone.zone..', purchase refunded',10)
                return 'No available supply convoys'
            end
        end
        bestCommander.targetzone=zonename
        bestCommander.state='preparing'
        bestCommander.urgent=true
        bestCommander.lastStateTime=timer.getAbsTime()-999999
        trigger.action.outTextForCoalition(2,'Emergency Capture from '..bestCommander.name..' heading to '..zonename,10)
        if supplyMenu then
            missionCommands.removeItemForCoalition(2,supplyMenu)
            supplyMenu=nil
        end
        return nil
    end)
    return nil
end,
function(sender,params)
    if not params.zone or params.zone.side~=0 then
        return 'Zone is not neutral'
    end
    local chosenZone=bc:getZoneByName(params.zone.zone)
    local bestCommander,status=findNearestAvailableSupplyCommander(chosenZone)
    if not bestCommander then
        if status=='inprogress' then
            return 'Supply mission in progress for this zone'
        else
            return 'No available supply convoys'
        end
    end
    bestCommander.targetzone=params.zone.zone
    bestCommander.state='preparing'
    bestCommander.urgent=true
    bestCommander.lastStateTime=timer.getAbsTime()-999999
    trigger.action.outTextForCoalition(2,'Emergency Capture from '..bestCommander.name..' heading to '..params.zone.zone,10)
    return nil
end)

local intelMenu=nil
bc:registerShopItem('intel','Intel on enemy zone',150,function(sender)
	if intelMenu then
		return 'Already choosing a zone'
	end
	local pickZone = function(targetZoneName)
		if intelMenu then
			local zoneObj = bc:getZoneByName(targetZoneName)
			if not zoneObj or zoneObj.side ~= 1 then
				return 'Must pick an enemy zone'
			end
			intelActiveZones[targetZoneName] = true
			trigger.action.outTextForCoalition(2, 'Intel available for '..targetZoneName..'. Check Zone status. Valid for 1 hour', 15)
			mist.scheduleFunction(function(zName)
				local zn = bc:getZoneByName(zName)
				if not zn or zn.side ~= 1 then return end
				if intelActiveZones[zName] then
					intelActiveZones[zName] = false
					trigger.action.outTextForCoalition(2, 'Intel on '..zName..' has expired.', 10)
				end
			end, {targetZoneName}, timer.getTime()+60*60)
			intelMenu = nil
		end
	end
	intelMenu = bc:showTargetZoneMenu(2, 'Choose Enemy Zone for Intel', pickZone, 1)
	trigger.action.outTextForCoalition(2, 'Intel purchase started. Select enemy zone from F10 menu.', 15)
end,
function(sender, params)
	if params.zone and params.zone.side == 1 then
		intelActiveZones[params.zone.zone] = true
		trigger.action.outTextForCoalition(2, 'Intel available for '..params.zone.zone..'. Check Zone status. Valid for 1 hour', 15)
		mist.scheduleFunction(function(zName)
			if intelActiveZones[zName] then
				intelActiveZones[zName] = false
				trigger.action.outTextForCoalition(2, 'Intel on '..zName..' has expired.', 10)
			end
		end, {params.zone.zone}, timer.getTime()+60*60)
	else
		return 'Must pick an enemy zone'
	end
end)
--end of menu


    bc:addShopItem(2, 'cap', -1)
    bc:addShopItem(2, 'cas', -1)
    bc:addShopItem(2, 'sead', -1)
    bc:addShopItem(2, 'supplies', -1)
	bc:addShopItem(2, 'supplies2', -1)
    bc:addShopItem(2, 'jtac', -1)
    bc:addShopItem(2, 'smoke', -1)
    bc:addShopItem(2, 'armor', -1)
    bc:addShopItem(2, 'artillery', -1)
    bc:addShopItem(2, 'recon', -1)
    bc:addShopItem(2, 'airdef', -1)
	bc:addShopItem(2, '9lineam', -1)
	bc:addShopItem(2, '9linefm', -1)
	bc:addShopItem(2, 'capture', -1)
	bc:addShopItem(2, 'intel', -1)
	
  

supplyZones = {
	'Blue Carrier',
	
	'Sde Dov',	
	'Ben-Gurion', 
	'Palmahim', 
	'Tel Nof', 
	'Hatzor', 
	'Kedem-Hatzerim', 
	'Nevatim', 
	'Ramon Airbase',
	'El Gora',
	'El Arish',
	'Ovda',
	'Bir Hasanah',
	'Melez',
	'Baluza',
	'Al Mansurah',
	'As Salihiyah',
	'Al Ismailiyah',

	'AzZaqaziq',
	'Kibrit Air Base',
	'Inshas Airbase',
	'Cairo International Airport',
	'Wadi al Jandali',
	'Cairo West',
	'Beni Suef',
	'Birma Air Base',
	
	'FARP-Alpha',
	'FARP-Bravo',
	'FARP-Charlie',
	'Gebel El Basur Air Base',
	'Kom Awshim'
}

lc = LogisticCommander:new({battleCommander = bc, supplyZones = supplyZones})
lc:init()

bc:loadFromDisk() --will load and overwrite default zone levels, sides, funds and available shop items
bc:init()
bc:startRewardPlayerContribution(15,{infantry = 10, ground = 10, sam = 30, structure=30, airplane = 30, ship = 250, helicopter=30, crate=200, rescue = 100})
HercCargoDropSupply.init(bc)


evc = EventCommander:new({ decissionFrequency=30*60, decissionVariance=30*60, skipChance = 10})
evc:init()

Group.getByName('Quwaysina-Scuds'):destroy()
evc:addEvent({
	id='Quwaysinascuds',
	action = function()
	mist.respawnGroup('Quwaysina-Scuds', true)
		timer.scheduleFunction(function(param, time)
			if Group.getByName('Quwaysina-Scuds') then
				local tgts = {
					'Melez',
					'As Salihiyah',
					'Al Ismailiyah',
					'Kibrit Air Base',
					'Wadi al Jandali',
					'Baluza'
				}
				
				local validtgts = {}
				for _,v in ipairs(tgts) do
					if bc:getZoneByName(v).side == 2 then
						table.insert(validtgts, v)
					end
				end
				
				if #validtgts == 0 then return time+(10*60) end
				
				local die = math.random(1,#validtgts)
				local choice = validtgts[die]
				bc:fireAtZone(choice, 'Quwaysina-Scuds', false, 8)
				trigger.action.outTextForCoalition(2, 'SCUDS near Gebel El Basur Air Base (31) are launching at '..choice, 15)
			end
		end, {}, timer.getTime()+(20*60))
	end,
	canExecute = function()
		if math.random(1, 100) > 50 then return false end
		
		local gr = Group.getByName('Quwaysina-Scuds')
		if gr then return false end
		
		if bc:getZoneByName('Gebel El Basur Air Base').side ~= 1 then return false end
		
		local triggers = {'Melez', 'Baluza', 'Kibrit Air Base'}
		for _,v in ipairs(triggers) do
			if bc:getZoneByName(v).side == 2 then
				return true
			end
		end		
		return false
	end
})



Group.getByName('Baluza-Scuds'):destroy()
evc:addEvent({
    id='Baluza-scuds',
    action = function()
		mist.respawnGroup('Baluza-Scuds', true)
        
		timer.scheduleFunction(function(param, time)
			if Group.getByName('Baluza-Scuds') then
				local tgts = {
					'Ramon Airbase',
					'El Arish',
					'El Gora',
					'Ovda',
				}
				
				local validtgts = {}
				for _,v in ipairs(tgts) do
					if bc:getZoneByName(v).side == 2 then
						table.insert(validtgts, v)
					end
				end
				
				if #validtgts == 0 then return time+(10*60) end
				
				local die = math.random(1,#validtgts)
				local choice = validtgts[die]
				bc:fireAtZone(choice, 'Baluza-Scuds', false, 8)
				trigger.action.outTextForCoalition(2, 'SCUDS near Baluza (14) are launching at '..choice, 15)
			end
		end, {}, timer.getTime()+(20*60))
	end,  
    canExecute = function()

        if math.random(1, 100) > 50 then return false end
        
        local gr = Group.getByName('Baluza-Scuds')
        if gr then return false end
        
        if bc:getZoneByName('Baluza').side ~= 1 then return false end
        if bc:getZoneByName('Melez').side ~= 2 then return false end
        
        local triggers = {'Ramon Airbase', 'El Gora', 'Ovda'}
        for _,v in ipairs(triggers) do
            if bc:getZoneByName(v).side == 2 then
                return true
            end
        end
        
        return false
    end
})

Group.getByName('evt-Salihiyah-attack-melez-art'):destroy()
evc:addEvent({
    id = 'artilleryattack',
    action = function()

        mist.respawnGroup('evt-Salihiyah-attack-melez-art', true)
    end,

    canExecute = function()

        if math.random(1, 100) < 99 then return false end

		if bc:getZoneByName('As Salihiyah').side ~= 1 then return false end
        if bc:getZoneByName('Melez').side ~= 2 then return false end
		if CustomFlags['SuezBridge'] == true then return false end
        if Group.getByName('evt-Salihiyah-attack-melez-art') then return false end

        return true
    end
})




Group.getByName('evt-shiptercept2'):destroy()
Group.getByName('evt-shiptercept3'):destroy()

evc:addEvent({
	id = 'shiptercept',
	action = function()
		local ships = {'evt-shiptercept2', 'evt-shiptercept3'}
		local choice = math.random(1, #ships)
		mist.respawnGroup(ships[choice], true)

		local shipDied = function(event)
			if event.id == 30 then
				if event.initiator and event.initiator.getName then
					local name = event.initiator:getName()
					if type(name)=="string" and name:find('^evt%-shiptercept') then
						if IsGroupActive(name) then
							return
						end
						mist.removeEventHandler(shipDieEvent)
						shipDieEvent = nil
						trigger.action.outTextForCoalition(2, 'Enemy supply ship destroyed.\n+500 credits', 15)
						bc:addFunds(2, 500)
					end
				end
			end
		end
		shipDieEvent = mist.addEventHandler(shipDied)
	end,

	canExecute = function()
		if math.random(1, 100) < 70 then return false end

		if Group.getByName('evt-shiptercept2')then return false end
		if Group.getByName('evt-shiptercept3')then return false end
		return true
	end
})
Group.getByName('evt-cargointercept1'):destroy()
Group.getByName('evt-cargointercept2'):destroy()
Group.getByName('evt-cargointercept3'):destroy()
local cargoDieEvent = nil
evc:addEvent({
	id='cargointercept',
	action = function()
	
		local planes = {'evt-cargointercept1','evt-cargointercept2','evt-cargointercept3'}
		local choice = math.random(1,#planes)
		
		mist.respawnGroup(planes[choice], true)
		
		local cargoDie = function(event)
			if event.id==30 then
				if event.initiator and event.initiator.getName then
					local name = event.initiator:getName()
					if type(name)=="string" and name:find('^evt%-cargointercept') then
						if IsGroupActive(name) then
							return
						end
						mist.removeEventHandler(cargoDieEvent)
						cargoDieEvent = nil
						trigger.action.outTextForCoalition(2,'Enemy cargo plane destroyed.\n+500 credits',15)
						bc:addFunds(2,500)
					end
				end
			end
		end
		cargoDieEvent = mist.addEventHandler(cargoDie)
	end,
	canExecute = function()
		if math.random(1,100) < 70 then return false end
		
		if bc:getZoneByName('Gebel El Basur Air Base').side ~= 1 then return false end
		if bc:getZoneByName('Cairo West').side ~= 1 then return false end
		
		if Group.getByName('evt-cargointercept1') then return false end
		if Group.getByName('evt-cargointercept2') then return false end
		if Group.getByName('evt-cargointercept3') then return false end
		
		return true
	end
})

mc = MissionCommander:new({side = 2, battleCommander = bc, checkFrequency = 60})


mc:trackMission({
	title = "Destroy SCUDS (31)",
	description = "SCUDS have been spotted at Gebel El Basur Air Base (31).\nDestroy them before they can launch their missiles",
	messageStart = "New mission: Destroy SCUDS",
	messageEnd = "Mission ended: Destroy SCUDS",
    startAction = function()
         if not missionCompleted and trigger.misc.getUserFlag(180) == 0 then
            trigger.action.outSoundForCoalition(2, "ding.ogg")
        end
    end,
    endAction = function()
         if not missionCompleted and trigger.misc.getUserFlag(180) == 0 then
            trigger.action.outSoundForCoalition(2, "cancel.ogg")
        end
    end,
	isActive = function()
		local gr = Group.getByName('Quwaysina-Scuds')
		if gr then return true else return false end
	end
})

mc:trackMission({
	title = "Destroy SCUDS (14).",
	description = "SCUDS have been spotted at Baluza (14).\nDestroy them before they can launch their missiles",
	messageStart = "New mission: Destroy SCUDS",
	messageEnd = "Mission ended: Destroy SCUDS",
    startAction = function()
         if not missionCompleted and trigger.misc.getUserFlag(180) == 0 then
            trigger.action.outSoundForCoalition(2, "ding.ogg")
        end
    end,
    endAction = function()
         if not missionCompleted and trigger.misc.getUserFlag(180) == 0 then
            trigger.action.outSoundForCoalition(2, "cancel.ogg")
        end
    end,
	isActive = function()
		local gr = Group.getByName('Baluza-Scuds')
		if gr then return true else return false end
	end
})

mc:trackMission({
	title = "Intercept cargo plane",
	description = "Find and destroy the enemy cargo plane taking and destroy it.",
	messageStart = "New mission: Intercept cargo plane",
	messageEnd = "Mission ended: Intercept cargo plane",
    startAction = function()
         if not missionCompleted and trigger.misc.getUserFlag(180) == 0 then
            trigger.action.outSoundForCoalition(2, "radio1.ogg")
        end
    end,
    endAction = function()
         if not missionCompleted and trigger.misc.getUserFlag(180) == 0 then
            trigger.action.outSoundForCoalition(2, "cancel.ogg")
        end
    end,
	isActive = function()
		if Group.getByName('evt-cargointercept1') then return true end
		if Group.getByName('evt-cargointercept2') then return true end
		if Group.getByName('evt-cargointercept3') then return true end
		
		return false
	end
})

mc:trackMission({
    title = "Destroy cargo & battle ships",
    description = function()
        return "New mission: Destroy cargo & battle ships"
    end,
    messageStart = "Mission started: Destroy cargo & battle ships",
    messageEnd = "Mission ended: Destroy cargo & battle ships",
    startAction = function()
        if not missionCompleted and trigger.misc.getUserFlag(180) == 0 then
            trigger.action.outSoundForCoalition(2, "radio2.ogg")
        end
    end,
    endAction = function()
        if not missionCompleted and trigger.misc.getUserFlag(180) == 0 then
            trigger.action.outSoundForCoalition(2, "cancel.ogg")
        end
    end,
    isActive = function()
        if Group.getByName('evt-shiptercept2') then return true end
        if Group.getByName('evt-shiptercept3') then return true end
        return false
    end
})

mc:trackMission({
	title = "Destroy artillery",
	description = "Artillery has been spotted heading towards Melez from the direction of As Salihiyah.\nDestroy them before they get in range.",
	messageStart = "New mission: Destroy artillery",
	messageEnd = "Mission ended: Destroy artillery heading to Melez\n+50 credits",
    startAction = function()
         if not missionCompleted and trigger.misc.getUserFlag(180) == 0 then
            trigger.action.outSoundForCoalition(2, "ding.ogg")
        end
    end,
    endAction = function()
         if not missionCompleted and trigger.misc.getUserFlag(180) == 0 then
            trigger.action.outSoundForCoalition(2, "cancel.ogg")
        end
    end,
	reward = 50,
	isActive = function()
		if Group.getByName('evt-salihiyah-attack-melez-art') then return true end
		return false
	end
})

resupplyTarget = nil
mc:trackMission({
    title = function()
        local wp = WaypointList[resupplyTarget] or ""
        return "Resupply " .. resupplyTarget .. wp
    end,
    description = function()
        return "Deliver supplies to " .. resupplyTarget end,
    messageStart = function()
        local wp = WaypointList[resupplyTarget] or ""
        return "New mission: Resupply " .. resupplyTarget .. wp
    end,
    messageEnd = function()
        return "Mission ended: Resupply " .. resupplyTarget end,
    startAction = function()
        if not missionCompleted and trigger.misc.getUserFlag(180) == 0 then
            trigger.action.outSoundForCoalition(2, "ding.ogg")
        end
    end,
    endAction = function()
		resupplyTarget = nil
        if not missionCompleted and trigger.misc.getUserFlag(180) == 0 then
            trigger.action.outSoundForCoalition(2, "cancel.ogg")
        end
    end,
    isActive = function()
        if not resupplyTarget then return false end

        local targetzn = bc:getZoneByName(resupplyTarget)
        return targetzn:canRecieveSupply()
    end
})
attackTarget = nil
mc:trackMission({
    title = function()
        local wp = WaypointList[attackTarget] or ""
        return "Attack " .. attackTarget .. wp
    end,
    description = function()
        local wp = WaypointList[attackTarget] or ""
        return "Destroy enemy forces at " .. attackTarget end,
    messageStart = function()
        local wp = WaypointList[attackTarget] or ""
        return "New mission: Attack " .. attackTarget .. wp
    end,
    messageEnd = function()
        return "Mission ended: Attack " .. attackTarget end,
    startAction = function()
         if not missionCompleted and trigger.misc.getUserFlag(180) == 0 then
            trigger.action.outSoundForCoalition(2, "cas.ogg")
        end
    end,
    endAction = function()
		attackTarget = nil
         if not missionCompleted and trigger.misc.getUserFlag(180) == 0 then
            trigger.action.outSoundForCoalition(2, "cancel.ogg")
        end
    end,
    isActive = function()
        if not attackTarget then return false end
        local targetzn = bc:getZoneByName(attackTarget)
        return targetzn.side == 1
    end
})


captureTarget = nil
mc:trackMission({
    title = function()
        local wp = WaypointList[captureTarget] or ""
        return "Capture " .. captureTarget .. wp
    end,
    description = function()
        return captureTarget .. " is neutral. Capture it by delivering supplies" end,
    messageStart = function()
        local wp = WaypointList[captureTarget] or ""
        return "New mission: Capture " .. captureTarget .. wp
    end,
    messageEnd = function()
        return "Mission ended: Capture " .. captureTarget end,
    startAction = function()
         if not missionCompleted and trigger.misc.getUserFlag(180) == 0 then
            trigger.action.outSoundForCoalition(2, "ding.ogg")
        end
    end,
    endAction = function()
		captureTarget = nil
         if not missionCompleted and trigger.misc.getUserFlag(180) == 0 then
            trigger.action.outSoundForCoalition(2, "cancel.ogg")
        end
    end,
    isActive = function()
        if not captureTarget then return false end

        local targetzn = bc:getZoneByName(captureTarget)
        return targetzn.side == 0 and targetzn.active
    end
})


function generateCaptureMission()
    if captureTarget ~= nil then return end
    
    local validzones = {}
    for _,v in ipairs(bc.zones) do
        
        if v.active and v.side == 0 and (not v.NeutralAtStart or v.firstCaptureByRed) then
            
            table.insert(validzones, v.zone)
        end
    end
    
    if #validzones == 0 then return end
    
    local choice = math.random(1, #validzones)
    if validzones[choice] then
        captureTarget = validzones[choice]
        return true
    end
end

---------------------------------------------------------------------
--                          CAP MISSION                            --

capMissionTarget = nil
capKillsByPlayer = {}
capTargetPlanes = 0
capWinner = nil
capMissionCooldownUntil = 0

mc:trackMission({
    title = function() return "CAP mission" end,
    description = function()
        if not next(capKillsByPlayer) then
            return "Kill "..capTargetPlanes.." A/A targets without getting shot down, who wins?"
        else
            local scoreboard = "Current Kill Count:\n"
            for playerName, kills in pairs(capKillsByPlayer) do
                scoreboard = scoreboard .. string.format("%s: %d\n", playerName, kills)
            end
            return string.format("Kill %d A/A targets, who wins?\n\n%s", capTargetPlanes, scoreboard)
        end
    end,
    messageStart = function()
        return "New CAP mission: Kill "..capTargetPlanes.." A/A targets." end,
    messageEnd = function() return "Mission ended: CAP" end,
    startAction = function()
        if not missionCompleted then
            trigger.action.outSoundForCoalition(2, "ding.ogg")
        end
    end,
    endAction = function()
        if capWinner then
            local reward = capTargetPlanes * 100
            capMissionCooldownUntil = timer.getTime() + 1800
            trigger.action.outTextForCoalition(2, "["..capWinner.."] completed the CAP mission!\nReward: "..reward.." credits", 20)
            bc:addFunds(2, reward)
        end
        capMissionTarget = nil
        capKillsByPlayer = {}
        capWinner = nil
        if not missionCompleted then
            trigger.action.outSoundForCoalition(2, "cancel.ogg")
        end
    end,
    isActive = function()
        if not capMissionTarget then return false end
        return true
    end
})

function checkAndGenerateCAPMission()
	if capMissionTarget ~= nil or timer.getTime() < capMissionCooldownUntil then
		return
	end
	local countInAir = 0
	for _, zC in pairs(bc.zones) do
		if zC.side == 1 and zC.active then
			for _, groupCom in ipairs(zC.groups) do
				if groupCom.side == 1
				and (groupCom.mission == 'attack' or groupCom.mission == 'patrol')
				and groupCom.state == 'inair' then
					countInAir = countInAir + 1
				end
			end
		end
	end
	local players = getBluePlayersCount()
	local limit = getCapLimit(players)
	if players == 0 then return end
	if countInAir >= 1 then
		capKillsByPlayer = {}
		if limit == 1 then
			capTargetPlanes = math.random(1,2)
		elseif limit == 2 then
			capTargetPlanes = math.random(2,3)
		elseif limit == 3 then
			capTargetPlanes = math.random(2,4)
		elseif limit == 4 then
			capTargetPlanes = math.random(3,6)
		elseif limit == 99999 then
			capTargetPlanes = math.random(3,6)
		end
		capWinner = nil
		capMissionTarget = "Active"
	end
end


---------------------------------------------------------------------
--                      End of CAP MISSION                         --


---------------------------------------------------------------------
--                      ESCORT MISSION                             --

function generateEscortMission(zoneName, groupName, groupID, group, mission)
    local mission = mission or missions[zoneName]
    if not mission then return false end

    missionGroupIDs[zoneName] = missionGroupIDs[zoneName] or {}
    missionGroupIDs[zoneName][groupID] = {
        groupID = groupID,
        group = group
    }
	    if IsGroupActive(mission.missionGroup) then
		trigger.action.outSoundForGroup(groupID, "ding.ogg")
		trigger.action.outTextForGroup(groupID, "Active mission is pending:\n\nEscort convoy from " .. mission.zone .. " to " .. mission.TargetZone, 30)
        return
    end
	if mc.missionFlags[zoneName] then
			trigger.action.outSoundForGroup(groupID, "ding.ogg")
			trigger.action.outTextForGroup(groupID, "Special mission available:\n\nEscort convoy from " .. mission.zone .. " to " .. mission.TargetZone, 30)
		return 
	end

    mc:trackMission({
        MainTitle = function() return "Escort mission" end,
        title = function() return "Escort mission" end,
		titleBefore = function(self)
			self.notified = true
			trigger.action.outSoundForGroup(groupID, "ding.ogg")
			trigger.action.outTextForGroup(groupID, "Special mission available:\n\nEscort convoy from " .. mission.zone .. " to " .. mission.TargetZone, 30)
		 end,
        description = function() return "\nEscort a convoy to " .. mission.TargetZone .. "\nThe roads are filled with hostile enemies." end,
        isEscortMission = true,
        accept = false,
        missionGroup = mission.missionGroup,
        zoneName = zoneName,
        reward = 1000,
        messageStart = function() return "Escort convoy to " .. mission.TargetZone end,
		missionFail = function(self)
		self.accept = false
		if not IsGroupActive(mission.missionGroup) then
			mc.missionFlags[zoneName] = nil
			if missionGroupIDs[zoneName] and next(missionGroupIDs[zoneName]) then
				for groupName, data in pairs(missionGroupIDs[zoneName]) do
					local groupID = data.groupID
					local group = data.group
					trigger.action.outSoundForGroup(groupID, "cancel.ogg")
					trigger.action.outTextForGroup(groupID, "Mission failed:\n\nConvoy was destroyed\n\nRestart the mission from the radio menu", 30)
					removeMissionMenuForAll(mission.zone, groupID)
					if trackedGroups[groupName] then
						trackedGroups[groupName] = nil
						handleMission(zoneName, groupName, groupID, group)
					end
				end
			else
				trigger.action.outSoundForCoalition(2, "cancel.ogg")
				trigger.action.outTextForCoalition(2, "Mission failed:\n\nConvoy was destroyed", 30)
				removeMissionMenuForAll(mission.zone, nil, true)
				destroyGroupIfActive(mission.missionGroup)
			end
			return true
		end
		return false
		end,
		startOver = function(self)
			timer.scheduleFunction(function()
		if missionGroupIDs[zoneName] then
			for groupName, data in pairs(missionGroupIDs[zoneName]) do
				local groupID = data.groupID
				local group = data.group
				handleMission(zoneName, groupName, groupID, group)
				return nil
			end
		end	
			end, nil, timer.getTime() + 10)
		end,
        startAction = function() return IsGroupActive(mission.missionGroup) end,
		endAction = function()
			local targetZone = bc:getZoneByName(mission.TargetZone)
			if targetZone.side == 2 and targetZone.active then
				if missionGroupIDs[zoneName] then
					for groupName, data in pairs(missionGroupIDs[zoneName]) do
						local groupID = data.groupID
						local group = data.group
						removeMissionMenuForAll(mission.zone, groupID)
						if trackedGroups[groupName] then
							trackedGroups[groupName] = nil
						end
						destroyGroupIfActive(mission.missionGroup)
						timer.scheduleFunction(function()
							handleMission(mission.TargetZone, groupName, groupID, group)
						end, nil, timer.getTime() + 30)
					end
				else
					removeMissionMenuForAll(mission.zone, nil, true)

					destroyGroupIfActive(mission.missionGroup)
				end
				mc.missionFlags[zoneName] = nil
				trigger.action.outSoundForCoalition(2, "ding.ogg")
				trigger.action.outTextForCoalition(2, "Escort mission complete!\n\nReward: 1000 credits", 20)
				return true
			end
			return false
		end,
        isActive = function()
            local targetZone = bc:getZoneByName(mission.TargetZone)
            if targetZone.side ~= 2 and targetZone.active then
                return true
            end
            return false
        end,
        returnAccepted = function(self)
            if not self.accept then return false end
            return IsGroupActive(mission.missionGroup)
        end,
    })

    mc.missionFlags[zoneName] = true
end

---------------------------------------------------------------------
--                     END OF ESCORT MISSION                       --


-- scenery and missions

local sceneryList = {
  ["factoryBulding"] = {SCENERY:FindByZoneName("factoryBulding")},
  ["factoryBulding2"] = {SCENERY:FindByZoneName("factoryBulding2")},
  ["factoryBulding3"] = {SCENERY:FindByZoneName("factoryBulding3")},
  ["SuezBridge"] = {SCENERY:FindByZoneName("SuezBridge")},
  ["FactoryStrike"] = {SCENERY:FindByZoneName("FactoryStrike")},

  
}

SCHEDULER:New(nil, function()
    for name, sceneries in pairs(sceneryList) do
        local allBelow50 = true
        for _, scenery in ipairs(sceneries) do
            if scenery and scenery:GetRelativeLife() > 50 then
                allBelow50 = false
                break
            end
        end
        if allBelow50 then
            CustomFlags[name] = true
        end
    end
end, {}, 5, 20)


Group.getByName('FactoryStrike'):destroy()
Group.getByName('Red SAM SA-3 Fixed SAM'):destroy()
local SecondManEvent = nil
evc:addEvent({
	id='FactoryStrike',
	action = function()
		mist.respawnGroup('FactoryStrike', true)
		
		local FactoryStrikeKilled = false
		local GeneralDie = function(event)
			if event.id == 30 and event.initiator and event.initiator.getName then
				local name = event.initiator:getName()
				if type(name)=="string" and name:find('FactoryStrike') then
					if not IsGroupActive('FactoryStrike') and (not FactoryStrikeKilled) then
						FactoryStrikeKilled = true
						mist.removeEventHandler(SecondManEvent)
						SecondManEvent = nil

						trigger.action.outTextForCoalition(2, 'Splash!', 15)
						mist.respawnGroup('Red SAM SA-3 Fixed SAM', true)
						bc:addFunds(2, 500)
						CustomFlags["FactoryStrike"] = true
					end
				end
			end
		end
		SecondManEvent = mist.addEventHandler(GeneralDie)
	end,
	canExecute = function()
		if bc:getZoneByName('Wadi al Jandali').side ~= 2 then return false end
		if CustomFlags["FactoryStrike"] then return false end
		if Group.getByName('FactoryStrike') then return false end
		return true
	end
})

mc:trackMission({
	title = "Strike High value target",
description = 
[[We have the location on a High value target.
South west of Wadi al Jandali, Take him out!.

Coordinates:
MGRS: 36 R UU 39157 01394
Lat Long: N 29°49'57" E 31°20'06"
Lat long Decimal Minutes: N 29°49.953' E 31°20.114'

Elevation: 86 feet

Reward: 500

Destroy the house and whoever is nearby.]],

	messageStart = "New strike mission: Strike High value target",
	messageEnd = "Strike mission ended: Strike High value target\n+500 credits",
    startAction = function()
         if not missionCompleted and trigger.misc.getUserFlag(180) == 0 then
            trigger.action.outSoundForCoalition(2, "ding.ogg")
        end
    end,
    endAction = function()
         if not missionCompleted and trigger.misc.getUserFlag(180) == 0 then
            trigger.action.outSoundForCoalition(2, "cancel.ogg")
        end
	end,
	isActive = function()
		if CustomFlags["FactoryStrike"] then return false end
		if Group.getByName('FactoryStrike') then return true end
		return false
	end
})


mc:trackMission({
	title = "Strike a High value factory",
	description = 
[[Strike a high-value factory just outside of Al Ismailiyah

Coordinates:
MGRS: 36 R VU 29372 86680
Lat long: N 30°36'38" E 32°15'47" 
Lat long Decimal Minutes: N 30°36.636' E 32°15.790'

Elevation: 16 feet

reward = 500]],
	messageStart = "New strike mission: Strike High value factory",
	messageEnd = "Strike mission ended: Strike High value factory\n+500 credits",
    startAction = function()
         if not missionCompleted and trigger.misc.getUserFlag(180) == 0 then
            trigger.action.outSoundForCoalition(2, "ding.ogg")
        end
    end,
    endAction = function()
         if not missionCompleted and trigger.misc.getUserFlag(180) == 0 then
            trigger.action.outSoundForCoalition(2, "cancel.ogg")
        end
	end,
	reward = 500,
	canExecute = function()
	if CustomFlags["factoryBulding"] then return false end
	if bc:getZoneByName('Melez').side ~= 2 then return false end
	if math.random(100) > 20 then return false end
		return true
	end,
	isActive = function()
	if CustomFlags["factoryBulding"] then return false end
	  return true
	end,
})

mc:trackMission({
	title = "Strike a High value factory",
	description = 
[[Strike a high-value factory just north of Al Mansurah

Coordinates:
MGRS: 36 R UV 48338 35521
Lat long: N 31°02'37" E 31°24'38"
Lat long Decimal Minutes: N 31°02.617' E 31°24.643'

Elevation: 7 feet

reward = 500]],
	messageStart = "New strike mission: Strike High value factory",
	messageEnd = "Strike mission ended: Strike High value factory\n+500 credits",
    startAction = function()
         if not missionCompleted and trigger.misc.getUserFlag(180) == 0 then
            trigger.action.outSoundForCoalition(2, "ding.ogg")
        end
    end,
    endAction = function()
         if not missionCompleted and trigger.misc.getUserFlag(180) == 0 then
            trigger.action.outSoundForCoalition(2, "cancel.ogg")
        end
	end,
	reward = 500,
	canExecute = function()
	if CustomFlags["factoryBulding2"] then return false end
	if bc:getZoneByName('As Salihiyah').side ~= 2 then return false end
	if math.random(100) > 20 then return false end
		return true
	end,
	isActive = function()
	if CustomFlags["factoryBulding2"] then return false end
	  return true
	end,
})

mc:trackMission({
	title = "Strike a High value factory",
	description = 
[[Strike a high-value factory just east of Baluza

Coordinates:
MGRS: 36 R WV 01224 31711
Lat long: N 31°01'08" E 33°00'46"
Lat long Decimal Minutes: N 31°01.141' E 33°00.769'

Elevation: 110 feet

reward = 500]],
	messageStart = "New strike mission: Strike High value factory",
	messageEnd = "Strike mission ended: Strike High value factory\n+500 credits",
    startAction = function()
         if not missionCompleted and trigger.misc.getUserFlag(180) == 0 then
            trigger.action.outSoundForCoalition(2, "ding.ogg")
        end
    end,
    endAction = function()
         if not missionCompleted and trigger.misc.getUserFlag(180) == 0 then
            trigger.action.outSoundForCoalition(2, "cancel.ogg")
        end
	end,
	reward = 500,
	canExecute = function()
	if bc:getZoneByName('Ramon Airbase').side ~= 2 then return false end
	if CustomFlags["factoryBulding3"] then return false end
	if math.random(100) > 20 then return false end
	  return true
	end,
	isActive = function()
	if CustomFlags["factoryBulding3"] then return false end
	  return true
	end,
})

mc:trackMission({
	title = "Strike the Suez Bridge",
	description = 
[[Strike a Suez Bridge to stop any ground attacks 
from the egypt side.

Coordinates:
MGRS: 36 R VV 34750 10772
Lat long: N 30°49'41" E 32°19'03"
Lat long Decimal Minutes: N 30°49.697' E 32°19.064'

Elevation: 0 feet

reward = 1000]],
	messageStart = "New strike mission: Strike the Suez Bridge",
	messageEnd = "Strike mission ended: Strike the Suez Bridge\n+1000 credits",
    startAction = function()
         if not missionCompleted and trigger.misc.getUserFlag(180) == 0 then
            trigger.action.outSoundForCoalition(2, "ding.ogg")
        end
    end,
    endAction = function()
         if not missionCompleted and trigger.misc.getUserFlag(180) == 0 then
            trigger.action.outSoundForCoalition(2, "cancel.ogg")
        end
	end,
	reward = 1000,
	canExecute = function()
	if CustomFlags["SuezBridge"] then return false end
	if bc:getZoneByName('Melez').side ~= 2 then return false end
	if math.random(100) > 20 then return false end
	  return true
	end,
	isActive = function()
	if CustomFlags["SuezBridge"] then return false end
	  return true
	end,
})

seadTarget = nil
function generateSEADMission()
    if seadTarget then return end
    if not attackTarget then return end

    local function isSEADZone(zone)
        local lname = zone.zone:lower()
        return zone.side == 1 and zone.active and (lname:find('sam') or lname:find('defence'))
    end

    local validSEADZones = {}
    local attackZone = bc:getZoneByName(attackTarget)

    if attackZone then
        for _, zone in ipairs(bc.zones) do
            if isSEADZone(zone) and measureDistanceZoneToZone(attackZone, zone) <= 18520 then
                table.insert(validSEADZones, zone.zone)
            end
        end
    end

    if #validSEADZones == 0 then
        for _, connection in ipairs(bc.connections) do
            local from = bc:getZoneByName(connection.from)
            local to = bc:getZoneByName(connection.to)

            if from.side ~= to.side and from.side ~= 0 and to.side ~= 0 then
                if isSEADZone(from) then
                    table.insert(validSEADZones, from.zone)
                end
                if isSEADZone(to) then
                    table.insert(validSEADZones, to.zone)
                end
            end
        end
    end

    if #validSEADZones == 0 then return end

    seadTarget = validSEADZones[math.random(#validSEADZones)]

    mc:trackMission({
        zone = seadTarget,
        missionType = "SEAD",
        title = function() return "SEAD mission at " .. seadTarget end,
        description = function() return "Neutralize enemy SAM/defences at " .. seadTarget end,
        messageStart = function() return "New SEAD mission: Engage SAM at " .. seadTarget end,
        messageEnd = function() return "SEAD mission ended: at " .. seadTarget end,
        startAction = function()
            if not missionCompleted then
                trigger.action.outSoundForCoalition(2, "ding.ogg") end
        end,
        endAction = function()
            seadTarget = nil
            if not missionCompleted then
                trigger.action.outSoundForCoalition(2, "cancel.ogg") end
        end,
        isActive = function()
            if not seadTarget then return false end
            local zn = bc:getZoneByName(seadTarget)
            return zn and zn.side == 1
        end
    })
end

function generateAttackMission()
    if missionCompleted then return end
    if attackTarget ~= nil then return end

    local validzones = {}
    for _, v in ipairs(bc.connections) do
        local to = bc:getZoneByName(v.to)
        local from = bc:getZoneByName(v.from)

        local function checkValid(zone)
			local lname = zone.zone:lower()
            return zone.side == 1 and zone.active and not isZoneUnderSEADMission(zone.zone)
			and not lname:find('sam') and not lname:find('defence')
        end

        if from.side ~= to.side and from.side ~= 0 and to.side ~= 0 then
            if checkValid(from) then
                table.insert(validzones, from.zone)
            elseif checkValid(to) then
                table.insert(validzones, to.zone)
            end
        end
    end

    if #validzones == 0 then return end

    local choice = math.random(1, #validzones)
    attackTarget = validzones[choice]
    return true
end


function generateSupplyMission()
	if resupplyTarget ~= nil then return end
		
	local validzones = {}
	for _,v in ipairs(bc.zones) do
		if v.side == 2 and v:canRecieveSupply() then
			table.insert(validzones, v.zone)
		end
	end
	
	if #validzones == 0 then return end
	
	local choice = math.random(1, #validzones)
	if validzones[choice] then
		resupplyTarget = validzones[choice]
		return true
	end
end

timer.scheduleFunction(function(_, time)
	if generateCaptureMission() then
		return time+300
	else
		return time+120
	end
end, {}, timer.getTime() + 20)

timer.scheduleFunction(function(_, time)
	if generateAttackMission() then
		return time+300
	else
		return time+120
	end
end, {}, timer.getTime() + 35)

timer.scheduleFunction(function(_, time)
	if generateSEADMission() then
		return time+300
	else
		return time+120
	end
end, {}, timer.getTime() + 55)
timer.scheduleFunction(function(_, time)
	if generateSupplyMission() then
		return time+300
	else
		return time+120
	end
end, {}, timer.getTime() + 60)
timer.scheduleFunction(function(_,time)
   if checkAndGenerateCAPMission() then
		return time+300
	else
		return time+120
	end
end, {}, timer.getTime() + 60)
mc:init()

----------------------- FLAGS --------------------------

local function checkZoneFlags()

		
	if zones.ramonairbase.wasBlue and zones.sambravo.wasBlue and not zones.melez.wasBlue then
		trigger.action.setUserFlag(2, true)
	end
	
	if zones.ramonairbase.wasBlue and zones.ovda.wasBlue and not zones.melez.wasBlue then
		trigger.action.setUserFlag(2, false)
		trigger.action.setUserFlag(127, true)
	end
	if zones.nevatim.wasBlue then
		trigger.action.setUserFlag(15, true)
	end
	
	if zones.alismailiyah.wasBlue and zones.inshasairbase.wasBlue and zones.kibritairbase.wasBlue then
		trigger.action.setUserFlag(7, true)

	end
	if zones.alismailiyah.wasBlue and zones.inshasairbase.wasBlue and zones.kibritairbase.wasBlue and
		zones.wadialjandali.wasBlue and zones.samgolf.wasBlue then
		trigger.action.setUserFlag(75, true)
		trigger.action.setUserFlag(7, false)
	end
	if trigger.misc.getUserFlag("cap") == 1 then
	  if not anyGroupAlive("f16cap") then
		destroyF16capGroups()
	  trigger.action.setUserFlag("cap", false)
	  end
	end

	if trigger.misc.getUserFlag("cas") == 1 then
	  if not anyGroupAlive("cas") then
		destroyCasGroups()
		trigger.action.setUserFlag("cas", false)
	  end
	end
	if trigger.misc.getUserFlag("decoy") == 1 then
	  if not anyGroupAlive("decoy") then
		destroydecoyGroups()
		trigger.action.setUserFlag("decoy", false)
	  end
	end
	if trigger.misc.getUserFlag("sead") == 1 then
	  if not anyGroupAlive("sead") then
		destroySeadGroups()
		trigger.action.setUserFlag("sead", false)
	  end
	end
end
timer.scheduleFunction(function()
    checkZoneFlags()
    return timer.getTime() + 30
end, {}, timer.getTime() + 2)

----------------------- END OF FLAGS --------------------------

env.info("Mission Setup is completed!")